#ifndef AXX_L1R_IMAGE_H
#define AXX_L1R_IMAGE_H

#include "xxx_ali_level1r.h"    /* L1R_IMAGE_ATTRIBUTES */

typedef struct L1R_SCA_BAND
{
    int32 number_of_dims;
    int32 dim_sizes[3];
    char8 name[9];
    int32 HDF_type;
    int32 number_of_attributes;
    L1R_IMAGE_ATTRIBUTES attributes;
    char filename[256]; /* name of file being read */
    int nl;
    int ns;
    int32 sd_id;        /* SD file id for the file opened */
    int32 sds_id;       /* SDS id for the band opened */
    int band;           /* band number being read (TBD which version?) */
    int band_index;     /* index in SDS for the band being read */
    int frame_shift;    /* frame shift for band being read */
} L1R_SCA_BAND;

L1R_SCA_BAND* axx_open_l1r_sca_band
(
    const char *l1r_file_name,  /* I: Level 1R file name for the SCA */
    BandNumber band             /* I: band to open */
);

int axx_close_l1r_sca_band
(
    L1R_SCA_BAND* image     /* I: image to close */
);

int axx_read_l1r_image
(
    L1R_SCA_BAND* image,    /* I: image to read */
    int sl,                 /* I: starting line to read */
    int ss,                 /* I: starting sample to read */
    int nl,                 /* I: number of lines to read */
    int ns,                 /* I: number of samples to read */
    short int *buffer       /* I/O: buffer for image data read */
);

#endif
