#include "xxx_LogStatus.h"
#include "axx_hdf_io.h"

/*
**
** MACROS
**
*/

#define USER_BAND_1  1
#define USER_BAND_2  2
#define USER_BAND_3  3
#define USER_BAND_4  4
#define USER_BAND_5  5
#define USER_BAND_6  6
#define USER_BAND_7  7
#define USER_BAND_8  8
#define USER_BAND_9  9
#define USER_BAND_10 10

/******************************************************************************
NAME:		axx_get_user_band

PURPOSE:	Return the enumerated BandNumber type to the number entered by 
                the user

RETURN VALUE: 
Type = int
Value              Description
-----              -----------
user_band_number   user band number for specified band

NOTES:		This function should be used to convert the enumerated band
                number type into the integer band number entered by the user.

ALGORITHM REFERENCES:
none

******************************************************************************/

int axx_get_user_band
(
    BandNumber band_number   /* I: enumerated band number to convert to 
                                   a user band number*/
)
{
    static int user_band_number[NBANDS] = 
    { USER_BAND_1, USER_BAND_2, USER_BAND_3, USER_BAND_4, USER_BAND_5, 
      USER_BAND_6, USER_BAND_7, USER_BAND_8, USER_BAND_9, USER_BAND_10};
    /* lookup table to convert the enumerated number to the user band
       number */

    /* if the enumerated type is in the legal range, return the 
       user band number, otherwise return berror */
    if ((band_number >= pan) && (band_number <= b7))
        return (user_band_number[band_number]);
    else
        {
	xxx_LogStatus("AXXLIB",__FILE__, __LINE__, "Error: band number out of range.");
        return (berror);
        }
}
