/******************************************************************************
NAME:		axx_parse_user_band

PURPOSE:	Convert between user band numbers and the internal enumerated
                band number.

ROUTINES:
    gxx_parse_user_band
    gxx_get_user_band


NOTES:		These functions should be used to convert the integer band 
                number entered by the user into the enumerated type used
                by the rest of the gps routines.

ALGORITHM REFERENCES:
none

******************************************************************************/
#include "xxx_LogStatus.h"
#include "axx_hdf_io.h"

/*
**
** MACROS
**
*/

#define USER_BAND_1  1
#define USER_BAND_2  2
#define USER_BAND_3  3
#define USER_BAND_4  4
#define USER_BAND_5  5
#define USER_BAND_6  6
#define USER_BAND_7  7
#define USER_BAND_8  8
#define USER_BAND_9  9
#define USER_BAND_10 10

/* define the values the user enters for the band numbers */


/******************************************************************************
NAME:		axx_parse_user_band

PURPOSE:	Parse the band number entered by the user into the enumerated 
		band type

RETURN VALUE: 
Type = int
Value           Description
-----           -----------
band_number     enumerated type band_number for specified band

NOTES:
none

ALGORITHM REFERENCES:
none

*******************************************************************************
		Landsat 7 Image Assessment System (IAS) Software
		        Property of the U.S. Government
                                NASA/GSFC/EDC
******************************************************************************/

BandNumber axx_parse_user_band(
	int user_band_number)	/* I: integer band number	*/
{
if (user_band_number == USER_BAND_1)
    return(pan);
else if (user_band_number == USER_BAND_2)
    return(b1p);
else if (user_band_number == USER_BAND_3)
    return(b1);
else if (user_band_number == USER_BAND_4)
    return(b2);
else if (user_band_number == USER_BAND_5)
    return(b3);
else if (user_band_number == USER_BAND_6)
    return(b4);
else if (user_band_number == USER_BAND_7)
    return(b4p);
else if (user_band_number == USER_BAND_8)
    return(b5p);
else if (user_band_number == USER_BAND_9)
    return(b5);
else if (user_band_number == USER_BAND_10)
    return(b7);
else 
    {
    return(berror);
    }
}
