/* axx_MakeALIBandString.c:    routine that determines the appropriate ALI
                               band name, given a 0-based band number.  */


#include <stdio.h>

#include "xxx_Types.h"
#include "xxx_LogStatus.h"
#include "axx_rps.h"


int axx_MakeALIBandString(
int32   band,                              /* I: 0-indexed band number */
char    bString[])                         /* O: Equivalent ALI band name */

{
  char msg[STRLEN];                        /* Message string */

  switch(band)
    {
    case 0:
      {
	sprintf(bString, "MS-1p");
	break;
      }
    case 1:
      {
	sprintf(bString, "MS-1");
	break;
      }
    case 2:
      {
	sprintf(bString, "MS-2");
	break;
      }
    case 3:
      {
	sprintf(bString, "MS-3");
	break;
      }
    case 4:
      {
	sprintf(bString, "MS-4");
	break;
      }
    case 5:
      {
	sprintf(bString, "MS-4p");
	break;
      }
    case 6:
      {
	sprintf(bString, "MS-5p");
	break;
      }
    case 7:
      {
	sprintf(bString, "MS-5");
	break;
      }
    case 8:
      {
	sprintf(bString, "MS-7");
	break;
      }
    case 9:
      {
	sprintf(bString, "PAN");
	break;
      }
    default:
      {
	sprintf(msg, "Invalid band number, aborting.");
	xxx_LogStatus("rps", __FILE__, __LINE__, msg);
	exit(ERROR);
      }
    }

  return SUCCESS;
}

