/* */
#include <stdio.h>
#include <stdlib.h>

#include "xxx_ali_level0r.h"
#include "axx_rps.h"
#include "xxx_Types.h"

int axx_average_states(
L0R_CAL *lamp,                   /* I: Structure containing level 0R lamp data */
CAL_INFO *cal_info)              /* O: Structure to contain bias information */
{
     int	det;             /* Current detector number */
     int32	state_loc[NUM_STATES]={30,488,943,1398};     /* Location of lamp states */
     int32      state_size[NUM_STATES]={400,400,400,400};    /* Size of lamp states */
     int	state;           /* Current lamp state */

  /* Note to self:
   * ...dim_sizes[0] -- number of bands
   * ...dim_sizes[1] -- number of frames
   * ...dim_sizes[2] -- number of detectors
   */

for(state=0;state<NUM_STATES;state++)
 {
   /* Average each detector for each lamp state */
   axx_vert_moment(&lamp->data[state_loc[state]*cal_info->ndets],
                   lamp->dim_sizes[N_DETS_IDX],
                   state_size[state],
                   &cal_info->gain.mean[state*cal_info->ndets],
                   &cal_info->gain.stddev[state*cal_info->ndets],
                   &cal_info->gain.num_valid_points[state*cal_info->ndets]);

   /* Calculate band averaged lamp states */
   for(det=0;det<cal_info->ndets;det++)
    {
      cal_info->gain.mean[det+state*cal_info->ndets]-=cal_info->offset.mean[det];
      cal_info->gain.band_average[state]+=cal_info->gain.mean[det+state*cal_info->ndets];
    }
   cal_info->gain.band_average[state]/=cal_info->ndets;
 }

  return(SUCCESS);
}
