/* */
#include <stdio.h>
#include <stdlib.h>

#include "xxx_ali_level0r.h"
#include "axx_rps.h"
#include "xxx_Types.h"

int axx_calc_bias_pan(
LEVEL0R *level0r,		/* I: Structure containing level 0R data */
CAL_INFO *cal_info,              /* O: Structure to contain bias information */
int32 band_num)                  /* I: 1-referenced index to band number */
{
     int	det;             /* Current detector number */
     int	frame;           /* Current frame number */
     int32	band;            /* Current band, one less than band_num */

  /* Note to self:
   * ...dim_sizes[0] -- number of bands
   * ...dim_sizes[1] -- number of frames
   * ...dim_sizes[2] -- number of detectors
   */

  band = band_num - 1;
  cal_info[band].ndets = level0r->dark[band].dim_sizes[N_DETS_IDX];

  /* Allocate and initialize all statistical pointers to zero
   * ---------------------------------------------------------------- */
  cal_info[band].offset.num_valid_points
           = (int32*)calloc(cal_info[band].ndets*3, sizeof(int32));
  cal_info[band].offset.mean
           = (float64*)calloc(cal_info[band].ndets*3, sizeof(float64));
  cal_info[band].offset.stddev
           = (float64*)calloc(cal_info[band].ndets*3, sizeof(float64));

  axx_vert_moment_pan(level0r->dark[band].data,
                  level0r->dark[band].dim_sizes[2],
                  level0r->dark[band].dim_sizes[1],
                  cal_info[band].offset.mean,
                  cal_info[band].offset.stddev,
                  cal_info[band].offset.num_valid_points);

  return(SUCCESS);
}
