#include "hdf.h"
#include "mfhdf.h"

#include "axx_rps.h"
#include "xxx_Types.h"

axx_calc_gain(
CAL_INFO cal_info)
{
     float64	*sxy;
     float64	*sx;
     float64	*sy;
     float64	*sxx;
     int32	det;
     int32	ii;
     int32	index;

/* Allocate memory for temporary variables */
sxy=(float64*)calloc(sizeof(float64),cal_info.ndets);
sx=(float64*)calloc(sizeof(float64),cal_info.ndets);
sy=(float64*)calloc(sizeof(float64),cal_info.ndets);
sxx=(float64*)calloc(sizeof(float64),cal_info.ndets);

/* Set cal_info.gain.p1 to gain using cal_info.gain.band_average, cal_info.gain.mean
 * and cal_info.ndets for each detector */
for(det=0;det<cal_info.ndets;det++)
 {
   for(ii=0;ii<NUM_LAMP_STATES;ii++)
    {
      index=det+ii*cal_info.ndets;
      sxy[det]+=cal_info.ic_lamp.det_mean[index]*cal_info.ic_lamp.band_average[ii];
      sx[det]+=cal_info.ic_lamp.det_mean[index];
      sy[det]+=cal_info.ic_lamp.band_average[ii];
      sxx[det]+=cal_info.ic_lamp.det_mean[index]*cal_info.ic_lamp.det_mean[index];
    }
   cal_info.gain.p1[det] = (cal_info.ndets*sxy[det]-sx[det]*sy[det])
                           /(cal_info.ndets*sxx[det]-sx[det]*sx[det]);
 }

/* Free memory for temporary variables */
free(sxy);
free(sx);
free(sy);
free(sxx);

return(SUCCESS);
}
