#include "xxx_Types.h"
#include "xxx_ali_level1r.h"
#include "xxx_ali_level0r.h"
#include "axx_rps.h"

int axx_calibrate_pan(
LEVEL0R *level0r,               /* I: Structure containing level 0R data */
CAL_INFO *cal_info,             /* I: Structure containing gain & bias information */
int32 band_num,                 /* I: 1-referenced index to band number */
LEVEL1R *level1r)               /* O: Structure to contian level 1R data */
{

     int32	cc;
     int32	band;
     int32	band_size;
     int32	det_num;
     int32	frame_num;
     int32	index;

  band=band_num-1;

  /* Generate level1r image */
for(cc=0;cc<3;cc++)
{
  for(frame_num=cc;frame_num<level0r->image[band].dim_sizes[N_FRAMES_IDX];frame_num+=3)
   {
     for(det_num=0;det_num<level0r->image[band].dim_sizes[N_DETS_IDX];det_num++)
      {
        /* NEED TO INCORPORATE GAIN */
        if((level0r->image[band].data[det_num+frame_num*level0r->image[band].dim_sizes[N_DETS_IDX]] & 0xf000) == 0)
           level1r->image[band].data[det_num+frame_num*level0r->image[band].dim_sizes[N_DETS_IDX]]
                     = (int16)((float64)level0r->image[band].data[det_num+frame_num*level0r->image[band].dim_sizes[N_DETS_IDX]]
                       - cal_info[band].offset.mean[det_num+cc*level0r->image[band].dim_sizes[N_DETS_IDX]]);
        else     /* Set fill data to zero for better stretches in ENVI */
           level1r->image[band].data[det_num+frame_num*level0r->image[band].dim_sizes[N_DETS_IDX]] = 0;
        index++;
      }
   }
}

  return(SUCCESS);

}
