#include "xxx_Types.h"                /* SUCCESS & ERROR defs */
#include "xxx_ali_level1r.h"          /* level 1R structures */
#include "xxx_ali_level0r.h"          /* level 0R structures */
#include "axx_rps.h"                  /* Generic ALI RPS header */


int axx_create_l1r_header(
L0R_HEADER l0header,			/* I: Structure containing level 0R header */
L1R_HEADER *l1header)			/* O: Structure to contain level 1R header */
{
  /* Copy from Level 0R header
   * ----------------------
   */
  memcpy(l1header->filename, l0header.filename,sizeof(l1header->filename));
  memcpy(l1header->software_version, l0header.software_version,sizeof(l1header->software_version));
  l1header->big_little_endian = l0header.big_little_endian;
  memcpy(l1header->time_of_generation, l0header.time_of_generation, sizeof(l1header->time_of_generation));
  l1header->number_of_related_files = l0header.number_of_related_files;
  memcpy(l1header->related_file1, l0header.related_file1, sizeof(l1header->related_file1));
  memcpy(l1header->related_file2, l0header.related_file2, sizeof(l1header->related_file2));
  memcpy(l1header->related_file3, l0header.related_file3, sizeof(l1header->related_file3));
  memcpy(l1header->related_file4, l0header.related_file4, sizeof(l1header->related_file4));
  memcpy(l1header->processing_notes, l0header.processing_notes, sizeof(l1header->processing_notes));
  memcpy(l1header->scene_id, l0header.scene_id, sizeof(l1header->scene_id));
  memcpy(l1header->target_description, l0header.target_description, sizeof(l1header->target_description));

  /* New to Level 1R header
   * ----------------------
   */
  l1header->data_product_level = 1;
  memcpy(l1header->type_of_DCE, "SCI", sizeof("SCI"));
  memcpy(l1header->cal_pipe_processing_notes, "EDC EO-1 Processor", sizeof("EDC EO-1 Processor"));
  l1header->cal_pipe_software_version[0] = 1;
  l1header->cal_pipe_software_version[1] = 1;
  l1header->cal_pipe_software_version[2] = 1;

  return(SUCCESS);
}
