/* axx_find_band_minmax():      routine to determine the maximum and minimum
                                raw detector response for a band, given
				each detector's minimum and maximum detector
				response. */

#include <stdio.h>
#include <stdlib.h>
#include "xxx_Types.h"
#include "xxx_LogStatus.h"
#include "axx_rps.h"

int axx_find_band_minmax(
int16    *pMaxArray,      /* I: Array of detector maximum responses */
int16    *pMinArray,      /* I: Array of detector minimum responses */
int32    num_dets,        /* I: Number of detectors per band */
int16    *pBandMax,       /* O: Maximum detector response for the band */
int16    *pBandMin)       /* O: Minimum detector response for the band */
{
  char   msg[STRLEN];
  int32  det;

  /* Set the starting maximum and minimum as the first detector's response. */
  *pBandMax = pMaxArray[0];
  *pBandMin = pMinArray[0];

  /* Go through the other detectors. */
  for(det = 1; det < num_dets; det++)
    {
      if(pMaxArray[det] > *pBandMax)
	*pBandMax = pMaxArray[det];

      if(pMinArray[det] < *pBandMin)
	*pBandMin = pMinArray[det];
    }

  return SUCCESS;
}

  
