/******************************************************************************
PROGRAM:  exx_get_units

PURPOSE:  Get the unit code from the name of the units.  The unit code returned
	  from this function can be entered into exx_projtran.

DEVELOPMENT HISTORY:
$Log: exx_get_units.c,v $
Revision 1.2  2001/01/03 19:27:35  storey
Added #include xxx_LogStatus.h and #include xxx_utility.h.

Revision 1.1  2000/11/22 22:20:54  storey
Original version - derived from gxx_get_units.c


*******************************************************************************
                        Property of the U.S. Government
                           USGS EROS Data Center
******************************************************************************/
#include "exx_geometric.h"
#include "xxx_utility.h"
#include "xxx_LogStatus.h"

int exx_get_units (
    char *unit_name,	/* I: Units name */
    int *unit_num)	/* O: Units number */
{

/* ensure that the unit name is upper case, compare names and assign the
   code number appropriatly
--------------------------------------------------------------------------*/
xxx_strtoupper(unit_name);
if(strcmp(unit_name, "RADIANS") == 0)
    *unit_num = 0;
else if(strcmp(unit_name, "FEET") == 0) 
    *unit_num = 1;
else if(strcmp(unit_name, "METERS") == 0) 
    *unit_num = 2;
else if(strcmp(unit_name, "SECONDS") == 0) 
    *unit_num = 3;
else if(strcmp(unit_name, "DEGREES") == 0) 
    *unit_num = 4;
else if(strcmp(unit_name, "DMS") == 0) 
    *unit_num = 5;
else
    {
    xxx_LogStatus("EXXLIB",__FILE__,__LINE__,
	"Illegal projection units for gctp");
    xxx_LogStatus("EXXLIB",__FILE__,__LINE__,
	"Valid units include RADIANS, FEET, METERS, SECONDS, DEGREES, and DMS");
    return(ERROR);
    }

return (SUCCESS);
}
