/*******************************************************************************
NAME: 	        exx_nutation 
	
PURPOSE:	
Transformation from the mean-of-date system to true-of-date system through
nutation angles.

DEVELOPMENT HISTORY:
$Log: exx_nutation.c,v $
Revision 1.1  2000/11/22 22:20:57  storey
Original version - derived from gxx_nutation.c


RETURN VALUE:
None

********************************************************************************
                       Property of the U.S. Government
                          USGS EROS Data Center
*******************************************************************************/
#include "exx_geometric.h"
#include "xxx_math.h"

void exx_nutation(VECTOR r_old, /* I: coordinates (x, y, z) in the
                                        mean-of-date system                  */
               double e,    /* I: nutation angle in radians                  */
               double ebar, /* I: nutation angle in radians                  */
               double psi,  /* I: nutation angle in radians                  */
               VECTOR *r_new) /* O: coordinates in the true-of-date
                                            equator and equinox sys.         */

{
  VECTOR vec1, vec2;		/* intermediate vectors		*/

  xxx_rotatex(r_old, ebar, &vec1);
  xxx_rotatez(vec1, -psi, &vec2);
  xxx_rotatex(vec2, -e, r_new);
}
