/******************************************************************************
NAME: 	        exx_precession(r_old, zi, theta, zeta, r_new)	

PURPOSE:	Transformation from J2000.0 sytem to mean-of-date system
		through precession angles.

DEVELOPMENT HISTORY:
$Log: exx_precession.c,v $
Revision 1.1  2000/11/22 22:20:59  storey
Original version - derived from gxx_precession.c


RETURN VALUE:
None

********************************************************************************
                       Property of the U.S. Government
                           USGS EROS Data Center
*******************************************************************************/
#include "exx_geometric.h"
#include "xxx_math.h"

void exx_precession(VECTOR r_old, /* I: coordinates (x, y, z) in the
                                             J2000.0 system                  */
                 double zi,    /* I: precession angle, in radians            */
                 double theta, /* I: precession angle, in radians            */
                 double zeta,  /* I: precession angle, in radians            */
                 VECTOR *r_new) /* O: coordinates in the mean-of-date
                                              equator and equinox sys.       */
{
  VECTOR vec1, vec2;		/* intermediate vectors		*/

  xxx_rotatez (r_old, -zeta, &vec1);
  xxx_rotatey (vec1, theta, &vec2);
  xxx_rotatez (vec2, -zi, r_new);
}
