/****************************************************************************
NAME:		gxx_sph2cart

PURPOSE:	Convert spherical coordinates to cartesian coordinates

PROGRAM HISTORY:
$LOG$

RETURN VALUE:
Type = int (SUCCESS or ERROR)

*****************************************************************************/
#include "gxx_geometric.h"

int  gxx_sph2cart(double *latp,
		  double *longp,
		  double *radius,
		  VECTOR *vec)
{
double	rcoslt;		/* Radius times cosine of the latitude constant      */

/*
  Calculate a constant to speed up calculations
*/
rcoslt = *radius * cos(*latp);

/*
  Calculate the cartesian coordinates for the vector
*/
vec->x = rcoslt * cos(*longp);
vec->y = rcoslt * sin(*longp);
vec->z = *radius * sin(*latp);

return SUCCESS;
}
