#ifndef _EXX_DEM_H_
#define _EXX_DEM_H_

#include "xxx_const.h" /* STRLEN definition */

/* DEM_DATA defines the data that is maintained for the Digital
   Elevation Model (DEM), including the DEM data itself and information
   about it such as size, min/max.  */
typedef struct DEM_DATA
    {
    char  filename[STRLEN];     /* name of DEM HDF file read for this data */
    short dem_min;		/* minimum elevation in the DEM (m) 	*/
    short dem_max;		/* maximum elevation in the DEM (m) 	*/
    short dem_nelevs;		/* number of elevations in the DEM 	*/
				/* (assumes increment of 1 m)		*/
    int   dem_samps_per_line;	/* number of samples per line in the DEM*/
    int   dem_nlines;		/* number of lines in the DEM 		*/
    short *dem_buf;		/* ptr to nlines by dem_samps_per_line buffer 
				   for the DEM image data 		*/
    double pixsize;		/* pixel size in m 			*/
    } DEM_DATA;

#endif
