#ifndef _EXX_GCPDATA_H_
#define _EXX_GCPDATA_H_

#include "xxx_const.h"
#include "xxx_structures.h"

/* GCPDATA is the structure for one entry in a GCP data file
   Note:  The band number of the reference image is set relative to 1.  Any one
	  band image will be set to 1.  The band number of the search
	  image will be set as an enumerater */

typedef struct GCPDATA {
    char   pt_id[PTIDLEN];	/* Ground Control Point ID 		*/
    double ref_line;		/* reference line 			*/
    double ref_samp;		/* reference sample 			*/
    double lat;			/* true latitude 			*/
    double lon;			/* true longitude 			*/
    double elev;		/* ground Control Point elevation 	*/
    VECTOR gcppos;		/* satellite position in cart space 	*/
    double pred_srch_line;	/* predicted line on the 1G image 	*/
    double pred_srch_samp;	/* predicted sample on the 1G image 	*/
    double fit_offset[2];	/* best-fit vertical (line) & horiziontal 
    				   (sample) offsets of correlation peak	*/
    int    accept_flg;		/* acceptance flag of the ground control point*/
    char   ref_name[STRLEN];	/* reference image name including path	*/
    int    ref_band;		/* band number of the reference image 	*/
    char   srch_name[STRLEN];	/* full search image name including path*/
    int    srch_band;		/* band number of the search image 	*/
    } GCPDATA;

#endif
