#ifndef _EXX_GCPLIB_H_
#define _EXX_GCPLIB_H_

#include "xxx_const.h"

#define CHIPREC 16
#define CHIPOUT 3

typedef struct GCPLIB
	{
	char pt_id[15];		/* Ground Control Point ID */
	char chip_name[STRLEN];	/* The name of the Chip image */
	double ref_line;	/* Reference line */
	double ref_samp;	/* Reference Sample */
	double lat;		/* true Latitude */
	double lon;		/* true longitude */
	double elev;		/* elevation at the gcp */
	double projy;		/* the predicted projection y coordinate value*/
	double projx;		/* the predicted projection x value */
	double pix_size[2];	/* The size of the pixel in meters
					[0] height
					[1] width */
	double ref_size[2];	/* Chip size [0] lines [1] sample */
	char source[STRLEN];	/* The source of the control */
	char date[11];		/* date of acquisition form mm/dd/yyyy */
	char abs_rel_flag[4];	/* Flag indicating if the source of the
				   latitude and longitude of the point was
				   absolute (abs) or relative (rel) */
	int  attempts;		/* times through the correlation process */
	int  good_corr;		/* points that had a good correlation */
	int  good_prec;		/* successful points through precision */
	}GCPLIB;

/* Add prototype for subroutine local to exx_gcplib  */

char *str2upper (char * string_ptr);

#endif
