/******************************************************************************
FUNCTION:	hxx_zero_hmodel

PURPOSE:	initialize the Hyperion model to all 0's

DEVELOPMENT HISTORY:

RETURN VALUE:
No return Value.

ALGORITHM REFERENCES:
  See hypmodel.h for description of the hypmodel structure.
*******************************************************************************/
#include <stdio.h>
#include <sys/types.h>
#include "hxx_hypmodel.h"

void hxx_zero_hmodel
(
  HYPMODEL *hmodel 	 /* O: hmodel to init to 0 */
)
{
long 	i,j;		  /* loopers */


/*----------------------------------------------------------------
 * Initialize the model structure to zeroes
 ----------------------------------------------------------------*/

hmodel->satnum = 0;
hmodel->l0r_sw_version[0] = 1;
hmodel->l0r_sw_version[1] = 1;
hmodel->l0r_sw_version[2] = 1;
hmodel->dce_time[0] = 0.0;
hmodel->dce_time[1] = 0.0;
hmodel->dce_time[2] = 0.0;
hmodel->acs_time[0] = 0.0;
hmodel->acs_time[1] = 0.0;
hmodel->acs_time[2] = 0.0;
hmodel->nephem = 0;
hmodel->ephem_type = ACSPTS;
hmodel->ephem_time[0] = 0.0;
hmodel->ephem_time[1] = 0.0;
hmodel->ephem_time[2] = 0.0;

/*----------------------------------------------------------------
 * Initialize precision and r-p-y values
 ----------------------------------------------------------------*/
hmodel->sc_roll = 0.0;
hmodel->sc_pitch = 0.0;
hmodel->sc_yaw = 0.0;
hmodel->correction_type = SYSTEMATIC;
hmodel->p_roll = 0.0;
hmodel->p_rrate = 0.0;
hmodel->p_pitch = 0.0;
hmodel->p_prate = 0.0;
hmodel->p_yaw = 0.0;
hmodel->p_yrate = 0.0;
hmodel->p_x = 0.0;
hmodel->p_vx = 0.0;
hmodel->p_y = 0.0;
hmodel->p_vy = 0.0;
hmodel->p_z = 0.0;
hmodel->p_vz = 0.0;
hmodel->p_ref_time = 0.0;

/*----------------------------------------------------------------
 * Initialize arrays of NPCD values
 ----------------------------------------------------------------*/

for (i=0; i<NPCD; i++)
  {
  hmodel->ecr_satpos[0][i] = 0.0;
  hmodel->ecr_satpos[1][i] = 0.0;
  hmodel->ecr_satpos[2][i] = 0.0;
  hmodel->ecr_satvel[0][i] = 0.0;
  hmodel->ecr_satvel[1][i] = 0.0;
  hmodel->ecr_satvel[2][i] = 0.0;
  hmodel->eci_satpos[0][i] = 0.0;
  hmodel->eci_satpos[1][i] = 0.0;
  hmodel->eci_satpos[2][i] = 0.0;
  hmodel->eci_satvel[0][i] = 0.0;
  hmodel->eci_satvel[1][i] = 0.0;
  hmodel->eci_satvel[2][i] = 0.0;
  }

/*----------------------------------------------------------------
 * Initialize arrays of NPCD values
 ----------------------------------------------------------------*/
for (i=0; i<NPCD; i++)
  {
  hmodel->rpy[i][0] = 0.0;
  hmodel->rpy[i][1] = 0.0;
  hmodel->rpy[i][2] = 0.0;
  }
}
