/******************************************************************************
NAME:		hxx_parse_user_band

PURPOSE:	Convert between user band numbers and the internal enumerated
                band number.

ROUTINES:
    hxx_parse_user_band
    hxx_get_user_band


NOTES:	These functions should be used to convert the integer band 
        number entered by the user into the enumerated type used
        by the rest of the gps routines.

ALGORITHM REFERENCES:
none

******************************************************************************/
#include "xxx_LogStatus.h"
#include "xxx_const.h"

/******************************************************************************
NAME:		hxx_parse_user_band

PURPOSE:	Parse the band number entered by the user into the enumerated 
		band type

RETURN VALUE: 
Type = int
Value           Description
-----           -----------
band_number     enumerated type band_number for specified band

NOTES:
none

ALGORITHM REFERENCES:
none

******************************************************************************/

HBandNumber hxx_parse_user_band(int user_band_number)	/* I: integer band number	*/
{
HBandNumber bandno[] = {herror,h1,h2,h3,h4,h5,h6,h7,h8,h9,h10,h11,h12,h13,h14,h15,h16,h17,h18,
            h19,h20,h21,h22,h23,h24,h25,h26,h27,h28,h29,h30,h31,h32,h33,h34,h35,h36,h37,h38,
            h39,h40,h41,h42,h43,h44,h45,h46,h47,h48,h49,h50,h51,h52,h53,h54,h55,h56,h57,h58,
            h59,h60,h61,h62,h63,h64,h65,h66,h67,h68,h69,h70,h71,h72,h73,h74,h75,h76,h77,h78,
            h79,h80,h81,h82,h83,h84,h85,h86,h87,h88,h89,h90,h91,h92,h93,h94,h95,h96,h97,h98,
            h99,h100,h101,h102,h103,h104,h105,h106,h107,h108,h109,h110,h111,h112,h113,h114,
            h115,h116,h117,h118,h119,h120,h121,h122,h123,h124,h125,h126,h127,h128,h129,h130,
            h131,h132,h133,h134,h135,h136,h137,h138,h139,h140,h141,h142,h143,h144,h145,h146,
            h147,h148,h149,h150,h151,h152,h153,h154,h155,h156,h157,h158,h159,h160,h161,h162,
            h163,h164,h165,h166,h167,h168,h169,h170,h171,h172,h173,h174,h175,h176,h177,h178,
            h179,h180,h181,h182,h183,h184,h185,h186,h187,h188,h189,h190,h191,h192,h193,h194,
            h195,h196,h197,h198,h199,h200,h201,h202,h203,h204,h205,h206,h207,h208,h209,h210,
            h211,h212,h213,h214,h215,h216,h217,h218,h219,h220,h221,h222,h223,h224,h225,h226,
            h227,h228,h229,h230,h231,h232,h233,h234,h235,h236,h237,h238,h239,h240,h241,h242};

   if( user_band_number < 1 || user_band_number > HYP_NBANDS ) 
   {
      return(herror);
   }
   else
       return(bandno[user_band_number]);
}
