#include <stdio.h>
#include "mfhdf.h"
#include "xxx_ACSHK.h"

int xxx_dump_ACS( ACS *ACS_Group )
{
  int32	index;		/* Dumper loop index */

  if ( ACS_Group == NULL )
  {
    printf("\nxxx_dump_ACS:  Invalid ACS telemetry structure.\n");
    return FAIL;
  }

  if ( (ACS_Group->quat1.count != ACS_Group->quat2.count) ||
       (ACS_Group->quat1.count != ACS_Group->quat3.count) ||
       (ACS_Group->quat1.count != ACS_Group->quat4.count) )
  {
    printf("\nQuaternion fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s,%s\n",
            ACS_Group->quat1.time_mnemonic,ACS_Group->quat1.value_mnemonic,
                                           ACS_Group->quat2.value_mnemonic,
                                           ACS_Group->quat3.value_mnemonic,
                                           ACS_Group->quat4.value_mnemonic );
    for ( index=0; index<ACS_Group->quat1.count; index++ )
      printf("%lf,%lf,%lf,%lf,%lf\n",
             ACS_Group->quat1.time[index],ACS_Group->quat1.value.d[index],
                                          ACS_Group->quat2.value.d[index],
                                          ACS_Group->quat3.value.d[index],
                                          ACS_Group->quat4.value.d[index] );
  }

  if ( (ACS_Group->imu_xrate.count != ACS_Group->imu_yrate.count) ||
       (ACS_Group->imu_xrate.count != ACS_Group->imu_zrate.count) )
  {
    printf("\nIMU rate fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s\n",
            ACS_Group->imu_xrate.time_mnemonic,ACS_Group->imu_xrate.value_mnemonic,
                                               ACS_Group->imu_yrate.value_mnemonic,
                                               ACS_Group->imu_zrate.value_mnemonic );
    for ( index=0; index<ACS_Group->imu_xrate.count; index++ )
      printf("%lf,%lf,%lf,%lf\n",
              ACS_Group->imu_xrate.time[index],ACS_Group->imu_xrate.value.d[index],
                                               ACS_Group->imu_yrate.value.d[index],
                                               ACS_Group->imu_zrate.value.d[index] );
  }

  if ( (ACS_Group->imu_xposerr.count != ACS_Group->imu_yposerr.count) ||
       (ACS_Group->imu_xposerr.count != ACS_Group->imu_zposerr.count) ||
       (ACS_Group->imu_xposerr.count != ACS_Group->imu_xraterr.count) ||
       (ACS_Group->imu_xposerr.count != ACS_Group->imu_yraterr.count) ||
       (ACS_Group->imu_xposerr.count != ACS_Group->imu_zraterr.count) )
  {
    printf("\nIMU error fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s,%s,%s,%s\n",
            ACS_Group->imu_xposerr.time_mnemonic,ACS_Group->imu_xposerr.value_mnemonic,
                                                 ACS_Group->imu_yposerr.value_mnemonic,
                                                 ACS_Group->imu_zposerr.value_mnemonic,
                                                 ACS_Group->imu_xraterr.value_mnemonic,
                                                 ACS_Group->imu_yraterr.value_mnemonic,
                                                 ACS_Group->imu_zraterr.value_mnemonic );
    for ( index=0; index<ACS_Group->imu_xposerr.count; index++ )
      printf("%lf,%lf,%lf,%lf,%lf,%lf,%lf\n",
              ACS_Group->imu_xposerr.time[index],ACS_Group->imu_xposerr.value.d[index],
                                                 ACS_Group->imu_yposerr.value.d[index],
                                                 ACS_Group->imu_zposerr.value.d[index],
                                                 ACS_Group->imu_xraterr.value.d[index],
                                                 ACS_Group->imu_yraterr.value.d[index],
                                                 ACS_Group->imu_zraterr.value.d[index] );
  }

  if ( (ACS_Group->sc_posx.count != ACS_Group->sc_posy.count) ||
       (ACS_Group->sc_posx.count != ACS_Group->sc_posz.count) ||
       (ACS_Group->sc_posx.count != ACS_Group->sc_velx.count) ||
       (ACS_Group->sc_posx.count != ACS_Group->sc_vely.count) ||
       (ACS_Group->sc_posx.count != ACS_Group->sc_velz.count) )
  {
    printf("\nSpacecraft position and velocity fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s,%s,%s,%s\n",
            ACS_Group->sc_posx.time_mnemonic,ACS_Group->sc_posx.value_mnemonic,
                                             ACS_Group->sc_posy.value_mnemonic,
                                             ACS_Group->sc_posz.value_mnemonic,
                                             ACS_Group->sc_velx.value_mnemonic,
                                             ACS_Group->sc_vely.value_mnemonic,
                                             ACS_Group->sc_velz.value_mnemonic );
    for ( index=0; index<ACS_Group->sc_posx.count; index++ )
      printf("%lf,%lf,%lf,%lf,%lf,%lf,%lf\n",
              ACS_Group->sc_posx.time[index],ACS_Group->sc_posx.value.d[index],
                                             ACS_Group->sc_posy.value.d[index],
                                             ACS_Group->sc_posz.value.d[index],
                                             ACS_Group->sc_velx.value.d[index],
                                             ACS_Group->sc_vely.value.d[index],
                                             ACS_Group->sc_velz.value.d[index] );
  }

  if ( (ACS_Group->sc_lat.count != ACS_Group->sc_lon.count) )
  {
    printf("\nSpacecraft latitude and longitude fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s\n",
            ACS_Group->sc_lat.time_mnemonic,ACS_Group->sc_lat.value_mnemonic,
                                            ACS_Group->sc_lon.value_mnemonic );
    for ( index=0; index<ACS_Group->sc_lat.count; index++ )
      printf("%lf,%lf,%lf\n",
              ACS_Group->sc_lat.time[index],ACS_Group->sc_lat.value.d[index],
                                            ACS_Group->sc_lon.value.d[index] );
  }

  if ( (ACS_Group->sunvecx.count != ACS_Group->sunvecy.count) ||
       (ACS_Group->sunvecx.count != ACS_Group->sunvecz.count) )
  {
    printf("\nSolar vector fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s\n",
            ACS_Group->sunvecx.time_mnemonic,ACS_Group->sunvecx.value_mnemonic,
                                             ACS_Group->sunvecy.value_mnemonic,
                                             ACS_Group->sunvecz.value_mnemonic );
    for ( index=0; index<ACS_Group->sunvecx.count; index++ )
      printf("%lf,%lf,%lf,%lf\n",
              ACS_Group->sunvecx.time[index],ACS_Group->sunvecx.value.d[index],
                                             ACS_Group->sunvecy.value.d[index],
                                             ACS_Group->sunvecz.value.d[index] );
  }

  if ( (ACS_Group->moonvecx.count != ACS_Group->moonvecy.count) ||
       (ACS_Group->moonvecx.count != ACS_Group->moonvecz.count) )
  {
    printf("\nLunar vector fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s\n",
            ACS_Group->moonvecx.time_mnemonic,ACS_Group->moonvecx.value_mnemonic,
                                              ACS_Group->moonvecy.value_mnemonic,
                                              ACS_Group->moonvecz.value_mnemonic );
    for ( index=0; index<ACS_Group->moonvecx.count; index++ )
      printf("%lf,%lf,%lf,%lf\n",
              ACS_Group->moonvecx.time[index],ACS_Group->moonvecx.value.d[index],
                                              ACS_Group->moonvecy.value.d[index],
                                              ACS_Group->moonvecz.value.d[index] );
  }

  if ( (ACS_Group->sc_momx.count != ACS_Group->sc_momy.count) ||
       (ACS_Group->sc_momx.count != ACS_Group->sc_momz.count) )
  {
    printf("\nSpacecraft momentum fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s\n",
            ACS_Group->sc_momx.time_mnemonic,ACS_Group->sc_momx.value_mnemonic,
                                             ACS_Group->sc_momy.value_mnemonic,
                                             ACS_Group->sc_momz.value_mnemonic );
    for ( index=0; index<ACS_Group->sc_momx.count; index++ )
      printf("%lf,%lf,%lf,%lf\n",
              ACS_Group->sc_momx.time[index],ACS_Group->sc_momx.value.d[index],
                                             ACS_Group->sc_momy.value.d[index],
                                             ACS_Group->sc_momz.value.d[index] );
  }

  return SUCCEED;
}

