#include <stdio.h>
#include "mfhdf.h"
#include "xxx_ALIHK.h"

int xxx_dump_ALI( ALI *ALI_Group )
{
  int32	index;		/* Dumper loop index */

  if ( ALI_Group == NULL )
  {
    printf("\nxxx_dump_ALI:  Invalid ALI telemetry structure.\n");
    return FAIL;
  }

  printf("%s,%s\n",
         ALI_Group->datamode.time_mnemonic,ALI_Group->datamode.value_mnemonic );
  for ( index=0; index<ALI_Group->datamode.count; index++ )
    printf("%lf,%d\n",
           ALI_Group->datamode.time[index],ALI_Group->datamode.value.us[index] );

  printf("%s,%s\n",
         ALI_Group->pan_int_time.time_mnemonic,ALI_Group->pan_int_time.value_mnemonic );
  for ( index=0; index<ALI_Group->pan_int_time.count; index++ )
    printf("%lf,%lf\n",
           ALI_Group->pan_int_time.time[index],ALI_Group->pan_int_time.value.d[index] );

  printf("%s,%s\n",
         ALI_Group->frame_rate.time_mnemonic,ALI_Group->frame_rate.value_mnemonic );
  for ( index=0; index<ALI_Group->frame_rate.count; index++ )
    printf("%lf,%lf\n",
           ALI_Group->frame_rate.time[index],ALI_Group->frame_rate.value.d[index] );

  printf("%s,%s\n",
         ALI_Group->dataset_type.time_mnemonic,ALI_Group->dataset_type.value_mnemonic );
  for ( index=0; index<ALI_Group->dataset_type.count; index++ )
    printf("%lf,%lf\n",
           ALI_Group->dataset_type.time[index],ALI_Group->dataset_type.value.d[index] );

  if ( (ALI_Group->starttime_msw.count != ALI_Group->starttime_lsw.count) ||
       (ALI_Group->starttime_msw.count != ALI_Group->starttime_sub.count) )
  {
    printf("\nALI start time fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s\n",
            ALI_Group->starttime_msw.time_mnemonic,ALI_Group->starttime_msw.value_mnemonic,
                                                   ALI_Group->starttime_lsw.value_mnemonic,
                                                   ALI_Group->starttime_sub.value_mnemonic );
    for ( index=0; index<ALI_Group->starttime_msw.count; index++ )
      printf("%lf,%lf,%lf,%lf\n",
              ALI_Group->starttime_msw.time[index],ALI_Group->starttime_msw.value.d[index],
                                                   ALI_Group->starttime_lsw.value.d[index],
                                                   ALI_Group->starttime_sub.value.d[index] );
  }

  if ( (ALI_Group->stoptime_msw.count != ALI_Group->stoptime_lsw.count) ||
       (ALI_Group->stoptime_msw.count != ALI_Group->stoptime_sub.count) )
  {
    printf("\nALI stop time fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s\n",
            ALI_Group->stoptime_msw.time_mnemonic,ALI_Group->stoptime_msw.value_mnemonic,
                                                  ALI_Group->stoptime_lsw.value_mnemonic,
                                                  ALI_Group->stoptime_sub.value_mnemonic );
    for ( index=0; index<ALI_Group->stoptime_msw.count; index++ )
      printf("%lf,%lf,%lf,%lf\n",
              ALI_Group->stoptime_msw.time[index],ALI_Group->stoptime_msw.value.d[index],
                                                  ALI_Group->stoptime_lsw.value.d[index],
                                                  ALI_Group->stoptime_sub.value.d[index] );
  }

  printf("%s,%s\n",
         ALI_Group->suncal_pos.time_mnemonic,ALI_Group->suncal_pos.value_mnemonic );
  for ( index=0; index<ALI_Group->suncal_pos.count; index++ )
    printf("%lf,%d\n",
           ALI_Group->suncal_pos.time[index],ALI_Group->suncal_pos.value.us[index] );

  printf("%s,%s\n",
         ALI_Group->cal_status.time_mnemonic,ALI_Group->cal_status.value_mnemonic );
  for ( index=0; index<ALI_Group->cal_status.count; index++ )
    printf("%lf,%lf\n",
           ALI_Group->cal_status.time[index],ALI_Group->cal_status.value.d[index] );

  printf("%s,%s\n",
         ALI_Group->int_time.time_mnemonic,ALI_Group->int_time.value_mnemonic );
  for ( index=0; index<ALI_Group->int_time.count; index++ )
    printf("%lf,%lf\n",
           ALI_Group->int_time.time[index],ALI_Group->int_time.value.d[index] );

  printf("%s,%s\n",
         ALI_Group->ms_int_time.time_mnemonic,ALI_Group->ms_int_time.value_mnemonic );
  for ( index=0; index<ALI_Group->ms_int_time.count; index++ )
    printf("%lf,%lf\n",
           ALI_Group->ms_int_time.time[index],ALI_Group->ms_int_time.value.d[index] );

  printf("%s,%s\n",
         ALI_Group->cover_pos.time_mnemonic,ALI_Group->cover_pos.value_mnemonic );
  for ( index=0; index<ALI_Group->cover_pos.count; index++ )
    printf("%lf,%lf\n",
           ALI_Group->cover_pos.time[index],ALI_Group->cover_pos.value.d[index] );

  return SUCCEED;
}

