#include <stdio.h>
#include "mfhdf.h"
#include "xxx_EFFHK.h"

int xxx_dump_EFF( EFF *EFF_Group )
{
  int32	index;		/* Dumper loop index */

  if ( EFF_Group == NULL )
  {
    printf("\nxxx_dump_EFF:  Invalid EFF telemetry structure.\n");
    return FAIL;
  }

  printf("%s,%s\n",
         EFF_Group->smode.time_mnemonic,EFF_Group->smode.value_mnemonic );
  for ( index=0; index<EFF_Group->smode.count; index++ )
    printf("%lf,%d\n",
           EFF_Group->smode.time[index],EFF_Group->smode.value.u[index] );

  printf("%s,%s\n",
         EFF_Group->utctime.time_mnemonic,EFF_Group->utctime.value_mnemonic );
  for ( index=0; index<EFF_Group->utctime.count; index++ )
    printf("%lf,%lf\n",
           EFF_Group->utctime.time[index],EFF_Group->utctime.value.d[index] );

  if ( (EFF_Group->l7_xpos.count != EFF_Group->l7_ypos.count) ||
       (EFF_Group->l7_xpos.count != EFF_Group->l7_zpos.count) )
  {
    printf("\nLandsat 7 position fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s\n",
            EFF_Group->l7_xpos.time_mnemonic,EFF_Group->l7_xpos.value_mnemonic,
                                             EFF_Group->l7_ypos.value_mnemonic,
                                             EFF_Group->l7_zpos.value_mnemonic );
    for ( index=0; index<EFF_Group->l7_xpos.count; index++ )
      printf("%lf,%lf,%lf,%lf\n",
              EFF_Group->l7_xpos.time[index],EFF_Group->l7_xpos.value.d[index],
                                             EFF_Group->l7_ypos.value.d[index],
                                             EFF_Group->l7_zpos.value.d[index] );
  }

  if ( (EFF_Group->eo1_xpos.count != EFF_Group->eo1_ypos.count) ||
       (EFF_Group->eo1_xpos.count != EFF_Group->eo1_zpos.count) )
  {
    printf("\nEO-1 position fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s\n",
            EFF_Group->eo1_xpos.time_mnemonic,EFF_Group->eo1_xpos.value_mnemonic,
                                              EFF_Group->eo1_ypos.value_mnemonic,
                                              EFF_Group->eo1_zpos.value_mnemonic );
    for ( index=0; index<EFF_Group->eo1_xpos.count; index++ )
      printf("%lf,%lf,%lf,%lf\n",
              EFF_Group->eo1_xpos.time[index],EFF_Group->eo1_xpos.value.d[index],
                                              EFF_Group->eo1_ypos.value.d[index],
                                              EFF_Group->eo1_zpos.value.d[index] );
  }

  if ( (EFF_Group->eo1_l7_relx.count != EFF_Group->eo1_l7_rely.count) ||
       (EFF_Group->eo1_l7_relx.count != EFF_Group->eo1_l7_relz.count) )
  {
    printf("\nEO-1/Landsat 7 relative position fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s\n",
            EFF_Group->eo1_l7_relx.time_mnemonic,EFF_Group->eo1_l7_relx.value_mnemonic,
                                                 EFF_Group->eo1_l7_rely.value_mnemonic,
                                                 EFF_Group->eo1_l7_relz.value_mnemonic );
    for ( index=0; index<EFF_Group->eo1_l7_relx.count; index++ )
      printf("%lf,%lf,%lf,%lf\n",
              EFF_Group->eo1_l7_relx.time[index],EFF_Group->eo1_l7_relx.value.d[index],
                                                 EFF_Group->eo1_l7_rely.value.d[index],
                                                 EFF_Group->eo1_l7_relz.value.d[index] );
  }

  return SUCCEED;
}

