#include <stdio.h>
#include "mfhdf.h"
#include "xxx_GPSHK.h"

int xxx_dump_GPS( GPS *GPS_Group )
{
  int32	index;		/* Dumper loop index */

  if ( GPS_Group == NULL )
  {
    printf("\nxxx_dump_GPS:  Invalid GPS telemetry structure.\n");
    return FAIL;
  }

  printf("%s,%s\n",
         GPS_Group->acsutctime.time_mnemonic,GPS_Group->acsutctime.value_mnemonic );
  for ( index=0; index<GPS_Group->acsutctime.count; index++ )
    printf("%lf,%lf\n",
           GPS_Group->acsutctime.time[index],GPS_Group->acsutctime.value.d[index] );

  printf("%s,%s\n",
         GPS_Group->utcftime.time_mnemonic,GPS_Group->utcftime.value_mnemonic );
  for ( index=0; index<GPS_Group->utcftime.count; index++ )
    printf("%lf,%lf\n",
           GPS_Group->utcftime.time[index],GPS_Group->utcftime.value.d[index] );

  if ( (GPS_Group->gps_posx.count != GPS_Group->gps_posy.count) ||
       (GPS_Group->gps_posx.count != GPS_Group->gps_posz.count) ||
       (GPS_Group->gps_posx.count != GPS_Group->gps_velx.count) ||
       (GPS_Group->gps_posx.count != GPS_Group->gps_vely.count) ||
       (GPS_Group->gps_posx.count != GPS_Group->gps_velz.count) )
  {
    printf("\nGPS position and velocity fields not the same dimensions.\n\n");
  }
  else
  {
    printf("%s,%s,%s,%s,%s,%s,%s\n",
            GPS_Group->gps_posx.time_mnemonic,GPS_Group->gps_posx.value_mnemonic,
                                              GPS_Group->gps_posy.value_mnemonic,
                                              GPS_Group->gps_posz.value_mnemonic,
                                              GPS_Group->gps_velx.value_mnemonic,
                                              GPS_Group->gps_vely.value_mnemonic,
                                              GPS_Group->gps_velz.value_mnemonic );
    for ( index=0; index<GPS_Group->gps_posx.count; index++ )
      printf("%lf,%lf,%lf,%lf,%lf,%lf,%lf\n",
              GPS_Group->gps_posx.time[index],GPS_Group->gps_posx.value.d[index],
                                              GPS_Group->gps_posy.value.d[index],
                                              GPS_Group->gps_posz.value.d[index],
                                              GPS_Group->gps_velx.value.d[index],
                                              GPS_Group->gps_vely.value.d[index],
                                              GPS_Group->gps_velz.value.d[index] );
  }

  return SUCCEED;
}

