#ifndef _XXX_HYP_LEVEL1R_H
#define _XXX_HYP_LEVEL1R_H

#include "hdf.h"
#include "mfhdf.h"

#include "xxx_const.h"                /* STRLEN and definitions */

/* -----------------------------------
   Level 0 R Constants
   ----------------------------------- */
#define         MAX_SDS_DIM     3
#define		VALID		1
#define		INVALID		0
#define		N_FILE_ATTRS	13  /* For L0R there are 13 file attributes */


typedef struct HYP_L1R_IMAGE_ATTRIBUTES
{
  char8 generated_by[19];
  char8 file_byte_order[11];
  char8 time_of_file_generation[16];
  int32 frame_range[2];
  int16 number_cross_track_pixels;
  int32 number_along_track_pixels;
  int32 number_of_bands;
  char8 interleave_format[4];
  uint32 pixels_with_missing_data_flag;
  char8 scene_id[22];
  char8 target_description[64];
  char8 time_met[18];
  char8 time_utc[18];
  int16 met_utc_adjust;
  int32 *vnir_sync_time;  
  int32 *vnir_time_code;
  int8 vnir_channel_offset[4];
  int32 *swir_time_code;
  int32 *swir_sync_time;
  int8 swir_channel_offset[4];
  int8 swir_gain_setting[4];
  int8 swir_int_setting;
  uint8 valid_map[22];
} HYP_L1R_IMAGE_ATTRIBUTES;

typedef struct HYP_L1R_IMAGE
{
  int32 number_of_dims;
  int32 dim_sizes[MAX_SDS_DIM];
  char8 name[9];
  int32 HDF_type;
  int32 number_of_attributes;
  HYP_L1R_IMAGE_ATTRIBUTES attributes;
  int16 *data;
} HYP_L1R_IMAGE;

typedef struct LEVEL1R
{
  HYP_L1R_IMAGE image;
} HYP_LEVEL1R;

int xxx_read_hyp_l1r_image_attributes(
char *l1r_name,                   /* I: Name of Level 0R file             */
HYP_L1R_IMAGE_ATTRIBUTES *image); /* O: Structure containing L0R data     */

void *xxx_read_hyp_l1r_band(
char *l1r_name,
int band,
int *nl,
int *ns,
DataType *type);

#endif
