/***************************************************************************
UNIT NAME:      xxx_init_level0r.c 

PURPOSE: Initializes the number_of_dims for all bands and sds's to 0's.
         This is used to indicate if each sds/band has been loaded into
         the level0r structure.  Mainly done because many scenes don't have
         the lamp data in them.
               
***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <sys/types.h>
#include <stddef.h>
#include "xxx_Types.h"
#include "xxx_LogStatus.h"
#include "xxx_ali_level0r.h"

int xxx_init_level0r(
LEVEL0R *level0r)	        /* I: Structure containing L0R data	*/
{
     int band;                  /* Band index */

for(band = 0; band<NUM_BAND; band++)
{
/* Initialize PRECAL */
   level0r->precal[band].number_of_dims = 0;
/* Initialize IMAGE */
   level0r->image[band].number_of_dims = 0;
/* Initialize DARK */
   level0r->dark[band].number_of_dims = 0;
/* Initialize LAMP */
   level0r->lamp[band].number_of_dims = 0;
}

return(SUCCESS);
}
