#include "mfhdf.h"
#include "xxx_ACSHK.h"

int xxx_read_ACS( int32 sd_id, ACS **ACS_Ptr )
{
  ACS *ACS_Group;		/* Local version of ACS pointer */
  ACS ACS_Data={
    {"A@ACSKFQ1C(TIME_MEASURED)","P@ACSKFQ1C",0,NULL,NULL},
    {"A@ACSKFQ2C(TIME_MEASURED)","P@ACSKFQ2C",0,NULL,NULL},
    {"A@ACSKFQ3C(TIME_MEASURED)","P@ACSKFQ3C",0,NULL,NULL},
    {"A@ACSKFQ4C(TIME_MEASURED)","P@ACSKFQ4C",0,NULL,NULL},
    {"A@ACSBDYXRATS(TIME_MEASURED)","P@ACSBDYXRATS",0,NULL,NULL},
    {"A@ACSBDYYRATS(TIME_MEASURED)","P@ACSBDYYRATS",0,NULL,NULL},
    {"A@ACSBDYZRATS(TIME_MEASURED)","P@ACSBDYZRATS",0,NULL,NULL},
    {"A@ACSPOSERRXC(TIME_MEASURED)","P@ACSPOSERRXC",0,NULL,NULL},
    {"A@ACSPOSERRYC(TIME_MEASURED)","P@ACSPOSERRYC",0,NULL,NULL},
    {"A@ACSPOSERRZC(TIME_MEASURED)","P@ACSPOSERRZC",0,NULL,NULL},
    {"A@ACSRATERRXC(TIME_MEASURED)","P@ACSRATERRXC",0,NULL,NULL},
    {"A@ACSRATERRYC(TIME_MEASURED)","P@ACSRATERRYC",0,NULL,NULL},
    {"A@ACSRATERRZC(TIME_MEASURED)","P@ACSRATERRZC",0,NULL,NULL},
    {"A@ACSSCPOSXE(TIME_MEASURED)","P@ACSSCPOSXE",0,NULL,NULL},
    {"A@ACSSCPOSYE(TIME_MEASURED)","P@ACSSCPOSYE",0,NULL,NULL},
    {"A@ACSSCPOSZE(TIME_MEASURED)","P@ACSSCPOSZE",0,NULL,NULL},
    {"A@ACSSCVELXE(TIME_MEASURED)","P@ACSSCVELXE",0,NULL,NULL},
    {"A@ACSSCVELYE(TIME_MEASURED)","P@ACSSCVELYE",0,NULL,NULL},
    {"A@ACSSCVELZE(TIME_MEASURED)","P@ACSSCVELZE",0,NULL,NULL},
    {"A@ACSSCLATE(TIME_MEASURED)","P@ACSSCLATE",0,NULL,NULL},
    {"A@ACSSCLONGE(TIME_MEASURED)","P@ACSSCLONGE",0,NULL,NULL},
    {"A@ACSSUNBDYXE(TIME_MEASURED)","P@ACSSUNBDYXE",0,NULL,NULL},
    {"A@ACSSUNBDYYE(TIME_MEASURED)","P@ACSSUNBDYYE",0,NULL,NULL},
    {"A@ACSSUNBDYZE(TIME_MEASURED)","P@ACSSUNBDYZE",0,NULL,NULL},
    {"A@ACSLUNBDYXE(TIME_MEASURED)","P@ACSLUNBDYXE",0,NULL,NULL},
    {"A@ACSLUNBDYYE(TIME_MEASURED)","P@ACSLUNBDYYE",0,NULL,NULL},
    {"A@ACSLUNBDYZE(TIME_MEASURED)","P@ACSLUNBDYZE",0,NULL,NULL},
    {"A@ACSSYSMOMXC(TIME_MEASURED)","P@ACSSYSMOMXC",0,NULL,NULL},
    {"A@ACSSYSMOMYC(TIME_MEASURED)","P@ACSSYSMOMYC",0,NULL,NULL},
    {"A@ACSSYSMOMZC(TIME_MEASURED)","P@ACSSYSMOMZC",0,NULL,NULL}
  };			/* ACS data structure template */

  /* Allocate ACS data structure */
  if ( (ACS_Group = (ACS *)malloc( sizeof( ACS ) )) == NULL )
  {
    printf("\nError allocating memory for ACS telemetry group\n\n");
    return FAIL;
  }

  /* Copy ACS template into new structure */
  memcpy( (void *)ACS_Group, (void *)&ACS_Data, sizeof( ACS ) );

  /* Read the ACS telemetry fields from their respective SDS's */
  if ( xxx_get_telem_field( sd_id, &ACS_Group->quat1 ) == FAIL )
  {
    printf("\nError reading ACS quat1 telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->quat2 ) == FAIL )
  {
    printf("\nError reading ACS quat2 telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->quat3 ) == FAIL )
  {
    printf("\nError reading ACS quat3 telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->quat4 ) == FAIL )
  {
    printf("\nError reading ACS quat4 telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->imu_xrate ) == FAIL )
  {
    printf("\nError reading ACS imu_xrate telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->imu_yrate ) == FAIL )
  {
    printf("\nError reading ACS imu_yrate telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->imu_zrate ) == FAIL )
  {
    printf("\nError reading ACS imu_zrate telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->imu_xposerr ) == FAIL )
  {
    printf("\nError reading ACS imu_xposerr telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->imu_yposerr ) == FAIL )
  {
    printf("\nError reading ACS imu_yposerr telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->imu_zposerr ) == FAIL )
  {
    printf("\nError reading ACS imu_zposerr telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->imu_xraterr ) == FAIL )
  {
    printf("\nError reading ACS imu_xraterr telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->imu_yraterr ) == FAIL )
  {
    printf("\nError reading ACS imu_yraterr telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->imu_zraterr ) == FAIL )
  {
    printf("\nError reading ACS imu_zraterr telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sc_posx ) == FAIL )
  {
    printf("\nError reading ACS sc_posx telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sc_posy ) == FAIL )
  {
    printf("\nError reading ACS sc_posy telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sc_posz ) == FAIL )
  {
    printf("\nError reading ACS sc_posz telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sc_velx ) == FAIL )
  {
    printf("\nError reading ACS sc_velx telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sc_vely ) == FAIL )
  {
    printf("\nError reading ACS sc_vely telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sc_velz ) == FAIL )
  {
    printf("\nError reading ACS sc_velz telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sc_lat ) == FAIL )
  {
    printf("\nError reading ACS sc_lat telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sc_lon ) == FAIL )
  {
    printf("\nError reading ACS sc_lon telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sunvecx ) == FAIL )
  {
    printf("\nError reading ACS sunvecx telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sunvecy ) == FAIL )
  {
    printf("\nError reading ACS sunvecy telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sunvecz ) == FAIL )
  {
    printf("\nError reading ACS sunvecz telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->moonvecx ) == FAIL )
  {
    printf("\nError reading ACS moonvecx telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->moonvecy ) == FAIL )
  {
    printf("\nError reading ACS moonvecy telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->moonvecz ) == FAIL )
  {
    printf("\nError reading ACS moonvecz telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sc_momx ) == FAIL )
  {
    printf("\nError reading ACS sc_momx telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sc_momy ) == FAIL )
  {
    printf("\nError reading ACS sc_momy telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &ACS_Group->sc_momz ) == FAIL )
  {
    printf("\nError reading ACS sc_momz telemetry field\n\n");
    xxx_free_ACS( ACS_Group );
    return FAIL;
  }

  *ACS_Ptr = ACS_Group;
  return SUCCEED;
}

