#include <stdio.h>
#include <string.h>

#include "xxx_ALIPCD.h"

int xxx_read_ALIPCD( ALIPCD *pcd, char *ddir, char *froot ) 
{
  int32	sd_id;
  char  file_name[VSNAMELENMAX+1];

  /* Initialize the housekeeping structures */
  pcd->active_DCE = -1;
  pcd->num_DCE = 0;
  pcd->ACS_Group = NULL;
  pcd->ALI_Group = NULL;
  pcd->GPS_Group = NULL;

  /* Construct ACS file name */
  xxx_hkfname( file_name, ddir, froot, "acs" );

  /* Attach to the ACS file */
  if ( (sd_id = SDstart(file_name, DFACC_READ)) == FAIL )
  {
    printf("\nError opening HDF file %s\n\n", file_name);
    return(FAIL);
  }

  /* Load the ACS file */
  if ( xxx_read_ACS( sd_id, &(pcd->ACS_Group) ) == FAIL )
  {
    printf("\nError reading ACS telemetry group\n\n");
    return(FAIL);
  }

  /* Release the ACS file */
  if ( SDend( sd_id ) == FAIL )
  {
    printf("\nError closing HDF file %s\n\n", file_name);
    return(FAIL);
  }

  /* Construct ALI file name */
  xxx_hkfname( file_name, ddir, froot, "ali" );

  /* Attach to the ALI file */
  if ( (sd_id = SDstart(file_name, DFACC_READ)) == FAIL )
  {
    printf("\nError opening HDF file %s\n\n", file_name);
    return(FAIL);
  }

  /* Load the ALI file */
  if ( xxx_read_ALI( sd_id, &(pcd->ALI_Group) ) == FAIL )
  {
    printf("\nError reading ALI telemetry group\n\n");
    return(FAIL);
  }

  /* Release the ALI file */
  if ( SDend( sd_id ) == FAIL )
  {
    printf("\nError closing HDF file %s\n\n", file_name);
    return(FAIL);
  }

  /* Construct GPS file name */
  xxx_hkfname( file_name, ddir, froot, "gps" );

  /* Attach to the GPS file */
  if ( (sd_id = SDstart(file_name, DFACC_READ)) == FAIL )
  {
    printf("\nError opening HDF file %s\n\n", file_name);
    return(FAIL);
  }

  /* Load the GPS file */
  if ( xxx_read_GPS( sd_id, &(pcd->GPS_Group) ) == FAIL )
  {
    printf("\nError reading GPS telemetry group\n\n");
    return(FAIL);
  }

  /* Release the GPS file */
  if ( SDend( sd_id ) == FAIL )
  {
    printf("\nError closing HDF file %s\n\n", file_name);
    return(FAIL);
  }

  /* Identify DCEs in the housekeeping data */
  if ( xxx_find_DCEs( pcd ) == FAIL )
  {
    printf("\nUnable to locate DCEs in housekeeping data\n\n");
    return(FAIL);
  }

  return(SUCCEED);
}
