#include "mfhdf.h"
#include "xxx_GPSHK.h"

int xxx_read_GPS( int32 sd_id, GPS **GPS_Ptr )
{
  GPS *GPS_Group;		/* Local version of GPS pointer */
  GPS GPS_Data={
    {"A@P052ACSUTCTIME(TIME_MEASURED)","P@P052ACSUTCTIME",0,NULL,NULL},
    {"A@MTCMETUTCF(TIME_MEASURED)","P@MTCMETUTCF",0,NULL,NULL},
    {"A@ACSGPSPOSXE(TIME_MEASURED)","P@ACSGPSPOSXE",0,NULL,NULL},
    {"A@ACSGPSPOSYE(TIME_MEASURED)","P@ACSGPSPOSYE",0,NULL,NULL},
    {"A@ACSGPSPOSZE(TIME_MEASURED)","P@ACSGPSPOSZE",0,NULL,NULL},
    {"A@ACSGPSVELXE(TIME_MEASURED)","P@ACSGPSVELXE",0,NULL,NULL},
    {"A@ACSGPSVELYE(TIME_MEASURED)","P@ACSGPSVELYE",0,NULL,NULL},
    {"A@ACSGPSVELZE(TIME_MEASURED)","P@ACSGPSVELZE",0,NULL,NULL}
  };			/* GPS data structure template */

  /* Allocate GPS data structure */
  if ( (GPS_Group = (GPS *)malloc( sizeof( GPS ) )) == NULL )
  {
    printf("\nError allocating memory for GPS telemetry group\n\n");
    return FAIL;
  }

  /* Copy GPS template into new structure */
  memcpy( (void *)GPS_Group, (void *)&GPS_Data, sizeof( GPS ) );

  /* Read the GPS telemetry fields from their respective SDS's */
  if ( xxx_get_telem_field( sd_id, &GPS_Group->acsutctime) == FAIL )
  {
    printf("\nError reading GPS acsutctime telemetry field\n\n");
    xxx_free_GPS( GPS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &GPS_Group->utcftime ) == FAIL )
  {
    printf("\nError reading GPS utcftime telemetry field\n\n");
    xxx_free_GPS( GPS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &GPS_Group->gps_posx ) == FAIL )
  {
    printf("\nError reading GPS gps_posx telemetry field\n\n");
    xxx_free_GPS( GPS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &GPS_Group->gps_posy ) == FAIL )
  {
    printf("\nError reading GPS gps_posy telemetry field\n\n");
    xxx_free_GPS( GPS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &GPS_Group->gps_posz ) == FAIL )
  {
    printf("\nError reading GPS gps_posz telemetry field\n\n");
    xxx_free_GPS( GPS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &GPS_Group->gps_velx ) == FAIL )
  {
    printf("\nError reading GPS gps_velx telemetry field\n\n");
    xxx_free_GPS( GPS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &GPS_Group->gps_vely ) == FAIL )
  {
    printf("\nError reading GPS gps_vely telemetry field\n\n");
    xxx_free_GPS( GPS_Group );
    return FAIL;
  }

  if ( xxx_get_telem_field( sd_id, &GPS_Group->gps_velz ) == FAIL )
  {
    printf("\nError reading GPS gps_velz telemetry field\n\n");
    xxx_free_GPS( GPS_Group );
    return FAIL;
  }

  *GPS_Ptr = GPS_Group;
  return SUCCEED;
}

