#include "mfhdf.h"
#include "xxx_HYPHK.h"

int xxx_read_HYP( int32 sd_id, HYP **HYP_Ptr )
{
  HYP *HYP_Group;		/* Local version of HYP pointer */
  HYP HYP_Data={
     {"A@YLAMP1CUR(TIME_MEASURED)","P@YLAMP1CUR",0,NULL,NULL},
     {"A@YLAMP2CUR(TIME_MEASURED)","P@YLAMP2CUR",0,NULL,NULL},
     {"A@YLAMP1VOL(TIME_MEASURED)","P@YLAMP1VOL",0,NULL,NULL},
     {"A@YLAMP2VOL(TIME_MEASURED)","P@YLAMP2VOL",0,NULL,NULL},
     {"A@YHSATMP5(TIME_MEASURED)","P@YHSATMP5",0,NULL,NULL},
     {"A@YHSATMP6(TIME_MEASURED)","P@YHSATMP6",0,NULL,NULL},
     {"A@YCOVERPOS(TIME_MEASURED)","P@YCOVERPOS",0,NULL,NULL},
     {"A@YSWIRFPET(TIME_MEASURED)","P@YSWIRFPET",0,NULL,NULL},
     {"A@YVNIRFPET(TIME_MEASURED)","P@YVNIRFPET",0,NULL,NULL},
     {"A@YHEAP5V(TIME_MEASURED)","P@YHEAP5V",0,NULL,NULL},
     {"A@YHEAP15V(TIME_MEASURED)","P@YHEAP15V",0,NULL,NULL},
     {"A@YHEAN15V(TIME_MEASURED)","P@YHEAN15V",0,NULL,NULL},
     {"A@YVNIRP5VD(TIME_MEASURED)","P@YVNIRP5VD",0,NULL,NULL},
     {"A@YVNIRP5VA(TIME_MEASURED)","P@YVNIRP5VA",0,NULL,NULL},
     {"A@YVNIRM5VA(TIME_MEASURED)","P@YVNIRM5VA",0,NULL,NULL},
     {"A@YVNIRP15VA(TIME_MEASURED)","P@YVNIRP15VA",0,NULL,NULL},
     {"A@YVNIRM15VA(TIME_MEASURED)","P@YVNIRM15VA",0,NULL,NULL},
     {"A@YSWIRP5VD(TIME_MEASURED)","P@YSWIRP5VD",0,NULL,NULL},
     {"A@YSWIRP5VA(TIME_MEASURED)","P@YSWIRP5VA",0,NULL,NULL},
     {"A@YSWIRM5VA(TIME_MEASURED)","P@YSWIRM5VA",0,NULL,NULL},
     {"A@YSWIRP15V(TIME_MEASURED)","P@YSWIRP15V",0,NULL,NULL},
     {"A@YSWIRM15V(TIME_MEASURED)","P@YSWIRM15V",0,NULL,NULL},
     {"A@YCLAMP12VOL(TIME_MEASURED)","P@YCLAMP12VOL",0,NULL,NULL},
     {"A@YERRCTR(TIME_MEASURED)","P@YERRCTR",0,NULL,NULL},
     {"A@YCOLDHEADTEMP(TIME_MEASURED)","P@YCOLDHEADTEMP",0,NULL,NULL},
     {"A@YOUTDBRSS(TIME_MEASURED)","P@YOUTDBRSS",0,NULL,NULL},
     {"A@YMOTORDRIVE(TIME_MEASURED)","P@YMOTORDRIVE",0,NULL,NULL},
     {"A@YCRYFLNGT2(TIME_MEASURED)","P@YCRYFLNGT2",0,NULL,NULL},
     {"A@YHEAOMST1(TIME_MEASURED)","P@YHEAOMST1",0,NULL,NULL},
     {"A@YVNIRASPT3(TIME_MEASURED)","P@YVNIRASPT3",0,NULL,NULL},
     {"A@YSWIRASPT4(TIME_MEASURED)","P@YSWIRASPT4",0,NULL,NULL},
     {"A@YVNRFPGATMP(TIME_MEASURED)","P@YVNRFPGATMP",0,NULL,NULL},
     {"A@YCENTERPLATETEMP(TIME_MEASURED)","P@YCENTERPLATETEMP",0,NULL,NULL},
     {"A@YPOS_PEAKPOSITION1(TIME_MEASURED)","P@YPOS_PEAKPOSITION1",0,NULL,NULL},
     {"A@YIMAGE_MODE(TIME_MEASURED)","YIMAGE_MODE",0,NULL,NULL},
     {"A@YCOVRSTAT(TIME_MEASURED)","YCOVRSTAT",0,NULL,NULL}
  };			/* HYP data structure template */

  /* Allocate HYP data structure */
  if ( (HYP_Group = (HYP *)malloc( sizeof( HYP ) )) == NULL )
  {
    printf("\nError allocating memory for HYP telemetry group\n\n");
    return(FAIL);
  }

  /* Copy ALI template into new structure */
  memcpy( (void *)HYP_Group, (void *)&HYP_Data, sizeof( HYP ) );

  /* Read the HYP telemetry fields from their respective SDS's */
  if ( xxx_get_telem_field( sd_id, &HYP_Group->ylamp1cur ) == FAIL )
  {
    printf("\nError reading HYP ylamp1cur telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->ylamp2cur ) == FAIL )
  {
    printf("\nError reading HYP ylamp2cur telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->ylamp1vol ) == FAIL )
  {
    printf("\nError reading HYP ylamp1vol telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->ylamp2vol ) == FAIL )
  {
    printf("\nError reading HYP ylamp2vol telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yhsatmp5 ) == FAIL )
  {
    printf("\nError reading HYP yhsatmp5 telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yhsatmp6 ) == FAIL )
  {
    printf("\nError reading HYP yhsatmp5 telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->ycoverpos ) == FAIL )
  {
    printf("\nError reading HYP ycoverpos telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yswirfpet ) == FAIL )
  {
    printf("\nError reading HYP yswirfpet telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yvnirfpet ) == FAIL )
  {
    printf("\nError reading HYP yvnirfpet telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yheap5v ) == FAIL )
  {
    printf("\nError reading HYP yheap5v telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yheap15v ) == FAIL )
  {
    printf("\nError reading HYP yheap15v telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yhean15v ) == FAIL )
  {
    printf("\nError reading HYP yhean15v telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yvnirp5vd ) == FAIL )
  {
    printf("\nError reading HYP yvnirp5vd telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yvnirp5va ) == FAIL )
  {
    printf("\nError reading HYP yvnirp5va telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yvnirm5va ) == FAIL )
  {
    printf("\nError reading HYP yvnirm5va telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yvnirp15va ) == FAIL )
  {
    printf("\nError reading HYP yvnirp15va telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yvnirm15va ) == FAIL )
  {
    printf("\nError reading HYP yvnirm15va telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yswirp5vd ) == FAIL )
  {
    printf("\nError reading HYP yswirp5vd telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yswirp5va ) == FAIL )
  {
    printf("\nError reading HYP yswirp5va telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yswirm5va ) == FAIL )
  {
    printf("\nError reading HYP yswirm5va telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yswirp15v ) == FAIL )
  {
    printf("\nError reading HYP yswirp15v telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yswirm15v ) == FAIL )
  {
    printf("\nError reading HYP yswirm15v telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->ycalmp12vol ) == FAIL )
  {
    printf("\nError reading HYP ycalmp12vol telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yerrctr ) == FAIL )
  {
    printf("\nError reading HYP yerrctr telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->ycoldheadtemp ) == FAIL )
  {
    printf("\nError reading HYP ycoldheadtemp telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->youtdbrss ) == FAIL )
  {
    printf("\nError reading HYP youtdbrss telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->ymotordrive ) == FAIL )
  {
    printf("\nError reading HYP ymotordrive telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->ycryflngt2 ) == FAIL )
  {
    printf("\nError reading HYP ycryflngt2 telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yheaomst1 ) == FAIL )
  {
    printf("\nError reading HYP yheaomst1 telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yvniraspt3 ) == FAIL )
  {
    printf("\nError reading HYP yvniraspt3 telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yswiraspt4 ) == FAIL )
  {
    printf("\nError reading HYP yswiraspt4 telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yvnrfpgatmp ) == FAIL )
  {
    printf("\nError reading HYP yvnrfpgatmp telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->ycenterplatetemp ) == FAIL )
  {
    printf("\nError reading HYP ycenterplatetemp telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->ypos_peakposition1 ) == FAIL )
  {
    printf("\nError reading HYP ypos_peakposition1 telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->yimage_mode ) == FAIL )
  {
    printf("\nError reading HYP yimage_mode telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  if ( xxx_get_telem_field( sd_id, &HYP_Group->ycoverstat ) == FAIL )
  {
    printf("\nError reading HYP ycoverstat telemetry field\n\n");
    xxx_free_HYP( HYP_Group );
    return(FAIL);
  }

  *HYP_Ptr = HYP_Group;
  return SUCCEED;
}
