#include <stdio.h>
#include <string.h>

#include "xxx_HYPPCD.h"

int xxx_read_HYPPCD( HYPPCD *pcd, char *ddir, char *froot ) 
{
  int32	sd_id;
  char  file_name[VSNAMELENMAX+1];

  /* Initialize the housekeeping structures */
  pcd->ACS_Group = NULL;
  pcd->HYP_Group = NULL;
  pcd->GPS_Group = NULL;

  /* Construct ACS file name */
  xxx_hkfname( file_name, ddir, froot, "acs" );

  /* Attach to the ACS file */
  if ( (sd_id = SDstart(file_name, DFACC_READ)) == FAIL )
  {
    printf("\nError opening HDF file %s\n\n", file_name);
    return(FAIL);
  }

  /* Load the ACS file */
  if ( xxx_read_ACS( sd_id, &(pcd->ACS_Group) ) == FAIL )
  {
    printf("\nError reading ACS telemetry group\n\n");
    return(FAIL);
  }

  /* Release the ACS file */
  if ( SDend( sd_id ) == FAIL )
  {
    printf("\nError closing HDF file %s\n\n", file_name);
    return(FAIL);
  }

  /* Construct hyp file name */
  xxx_hkfname( file_name, ddir, froot, "hyp" );

  /* Attach to the GPS file */
  if ( (sd_id = SDstart(file_name, DFACC_READ)) == FAIL )
  {
    printf("\nError opening HDF file %s\n\n", file_name);
    return(FAIL);
  }

  /* Load the GPS file */
  if ( xxx_read_HYP( sd_id, &(pcd->HYP_Group) ) == FAIL )
  {
    printf("\nError reading HYPGPS telemetry group\n\n");
    return(FAIL);
  }

  /* Construct GPS file name */
  xxx_hkfname( file_name, ddir, froot, "gps" );

  /* Attach to the GPS file */
  if ( (sd_id = SDstart(file_name, DFACC_READ)) == FAIL )
  {
    printf("\nError opening HDF file %s\n\n", file_name);
    return(FAIL);
  }

  /* Load the GPS file */
  if ( xxx_read_GPS( sd_id, &(pcd->GPS_Group) ) == FAIL )
  {
    printf("\nError reading GPS telemetry group\n\n");
    return(FAIL);
  }

  /* Release the GPS file */
  if ( SDend( sd_id ) == FAIL )
  {
    printf("\nError closing HDF file %s\n\n", file_name);
    return(FAIL);
  }

  return(SUCCEED);
}
