/******************************************************************************
*                              PACOR II SOFTWARE
*                      Property of the U.S. Government
*                              NASA/GSFC/Code 560
*******************************************************************************
*
*
*    UNIT NAME:
*	xxx_CloseUnmap.h
*
*
*    PURPOSE:
*	Defines function prototype for xxx_CloseUnmap.c and constants.
*
*
*    INVOCATION METHOD:
*	#include <xxx_CloseUnmap.h>
*
*
*    EXTERNAL FILE/RECORD REFERENCES:
*
*       NAME		USE	DESCRIPTION
*       ----		---	-------------------------------------
*	sys/mman.h	I	Header file needed for memory mapping support
*	xxx_Types.h	I	Includes PACORII type common type definitions
*
* 
*    CHANGE HISTORY:
*
*				  BUILD/
*    	AUTHOR	      CHANGE-ID	  RELEASE      DATE     DESCRIPTION OF CHANGE
*    	-----------   ---------	  --------   --------   -----------------------
*	J. Kerich     PAC2940631  R2.2       12/28/93   Original Implementation
*       J. kerich                 R1.0       03/24/97   Ported to IAS
*
*
*    NOTES:
*	Unit was originally pxx_Remap.c
*
*
**************************************************************************/

#ifndef XXX_CLOSEUNMAP_H
#define XXX_CLOSEUNMAP_H

#ifndef _SYS_MMAN_H
#include <sys/mman.h>
#endif

#ifndef XXX_TYPES_H
#include <xxx_Types.h>
#endif

/* error conditions */
#define XXX_CLOSE_ERR	5	/* Indicates file close error */
#define XXX_UNMAP_ERR	6	/* Indicates unmap error */

int	xxx_CloseUnmap(int, void *, long, boolean, boolean, char *);

#endif

