/******************************************************************************
*                              PACOR II SOFTWARE
*                      Property of the U.S. Government
*                              NASA/GSFC/Code 560
*******************************************************************************
*
*    UNIT NAME:
*       xxx_GetTempName.h       
*
*
*    PURPOSE:
*       Create a name for a temporary file using the non-POSIX tempnam() 
*       system call.
*
*
*    INVOCATION METHOD:
*       #include <xxx_GetTempName.h>
*
*
*    EXTERNAL FILE/RECORD REFERENCES:
*
*       NAME                USE DESCRIPTION
*       --------            --- -------------------------------------
*       None
*
*
*    NON-PORTABLE CODE:
*
*       DESCRIPTION REASON FOR USE      SUGGESTED PORTING PROCEDURES
*       ----------- ---------------     ---------------------------------------
*       tempnam()   To create a name
*                   for a temporary file
*
*
*    CHANGE HISTORY:
*
*                     BUILD/
*       AUTHOR        CHANGE-ID   RELEASE      DATE     DESCRIPTION OF CHANGE
*       -----------   ---------   --------   --------   -----------------------
*       R. Roth       N/A         R1B2       11/29/93   Original Implementation
*
*
*    NOTES:
*   none
*
******************************************************************************/

#ifndef XXX_GETTMPNAME_H        
#define XXX_GETTMPNAME_H

char * xxx_GetTempName(const char *dir, const char *pfx);

#endif

