/******************************************************************************
*                              PACOR II SOFTWARE
*                      Property of the U.S. Government
*                              NASA/GSFC/Code 560
*******************************************************************************
*
*
*    UNIT NAME:
*	xxx_OpenMap.h
*
*
*    PURPOSE:
*	Defines function prototype for xxx_OpenMap.c and constants
*
*
*    INVOCATION METHOD:
*	#include <xxx_OpenMap.h>
*
*
*    EXTERNAL FILE/RECORD REFERENCES:
*
*       NAME		USE	DESCRIPTION
*       ----		---	-------------------------------------
*	sys/mman.h	I	Header file needed for memory mapping support
*	xxx_Types.h	I	Includes PACORII type common type definitions
*
* 
*    CHANGE HISTORY:
*
*					  BUILD/
*    	AUTHOR		     CHANGE-ID	  RELEASE      DATE     DESCRIPTION OF CHANGE
*    	----------- 	     ---------	  --------   --------   -----------------------
*	J. Kerich	     PAC2940631   R2.2       12/28/94   Original Implementation
*       J. kerich                         R1.0        03/24/97  Ported to IAS
*
*
*    NOTES:
*	Unit was originally pxx_open_map.h
*
*
**************************************************************************/

#ifndef XXX_OPENMAP_H
#define XXX_OPENMAP_H

#ifndef _SYS_MMAN_H
#include <sys/mman.h>
#endif

#ifndef XXX_TYPES_H
#include <xxx_Types.h>
#endif

/* error conditions */
#define XXX_OPEN_ERR		1	/* File open error */
#define XXX_STAT_ERR		2	/* File status error */
#define XXX_MMAP_ERR		3	/* Memory map error */
#define XXX_MMAP_ZERO_ERR	4	/* Indicates zero file size on memory map request */

int	xxx_OpenMap(char *, int *, int, void **, off_t, long *, long *, boolean, boolean, char *);
#endif

