/******************************************************************************
  GPS geometric include file
   this file includes:
     function prototypes for the GPS geometric library
*******************************************************************************/
#ifndef _GXX_GEOMETRIC_H_
#define _GXX_GEOMETRIC_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <values.h>

#include "xxx_Types.h"
#include "xxx_LogError.h"
#include "xxx_DDR.h"
#include "xxx_const.h"
#include "xxx_structures.h"
#include "exx_cpf.h"
#include "axx_grid.h"
#include "xxx_proj.h"

void xxx_eval (int, const double *, double, double, double *);
double xxx_eval_poly( int, double *, double, double );
int xxx_get_units ( char *unit_name, int *unit_num);
int xxx_grid_cell_poly( axx_GRID_BAND_TYPE * );

int xxx_decdeg ( double *angle, char *coform, char *type);
int xxx_degdms ( double *deg, double *dms, char *code, char *check);
int xxx_find_deg ( double angle, int *degree);
int xxx_find_min ( double angle, int *minute);
int xxx_find_sec ( double angle, double *sec);
int xxx_proj_err ( int err);
int xxx_projtran (  int *inproj, int *inunit, int *inzone, double *inparm,
  int *inspheroid, int *outproj, int *outunit, int *outzone,
  double *outparm, int *outspheroid, double *inx, double *iny, double *outx,
  double *outy);
xxx_DDRControl_TYPE *xxx_ReadDDR(char *p_PathName, char *p_ErrorMessage);
int xxx_WriteDDR(char *p_PathName, xxx_DDRControl_TYPE *p_DDRControl,
                 char *p_ErrorMessage);

#endif
