#ifndef _GXX_SYSTBL_H_
#define _GXX_SYSTBL_H_

#include "xxx_const.h"

/* GPS sytem table entries */
typedef struct GPS_SYSTBL {
    int  add_process_noise;		/* sensor alignment calibration	*/
    float variance_process_noise[12]; 	/* sensor alignment calibration */
    int  add_observation_noise;		/* sensor alignment calibration */
    float variance_observation_noise[6];/* sensor alignment calibration*/
    float line_weights[9];		/* band2band fp calibration */
					/* first 8 are band weights in pixels, 
					   last is constraint weight in urad */
    float samp_weights[9];		/* band2band fp calibration */
					/* first 8 are band weights in pixels, 
					   last is constraint weight in urad */
    char  md_err_file_name[STRLEN];	/* tminit */
    float md_tolerances[4];		/* tminit */
					/* frst 2 are corner tolerances in m, 
					   scd 2 are sun angle tols in degrees*/
    int  spheroid;			/* tmgrid */
					/* spheroid code; default 0 indicates 
					   WGS84 */
    char  datum[16];			/* tmgrid */
					/* datum code; default 0 indicates 
					   WGS84 */
    float min_corr_focal_plane;       	/* focal plane */
    					/* minimum acceptable correlation 
    					   strength */
    float min_corr_gcp_corr;       	/* gcpcorrelate */
    					/* minimum acceptable correlation 
    					   strength */
    float min_corr_i2i_char;       	/* image to image characterization */
    					/* minimum acceptable correlation 
    					   strength */
    float min_corr_b2b_char;       	/* band to band characterization */
    					/* minimum acceptable correlation 
    					   strength */
    float max_disp_focal_plane;       	/* focal plane */
    					/* maximum allowed diagonal displacement
    					   from nominal tiepoint loc to location
					   found by correlation */
    float max_disp_gcp_corr;       	/* gcpcorrelate */
    					/* maximum allowed diagonal displacement
    					   from nominal tiepoint loc to location
					   found by correlation */
    float max_disp_i2i_char;       	/* image to image characterization */
    					/* maximum allowed diagonal displacement
    					   from nominal tiepoint loc to location
					   found by correlation */
    float max_disp_b2b_char;       	/* band to band characterization */
    					/* maximum allowed diagonal displacement
    					   from nominal tiepoint loc to location
					   found by correlation */
    float nom_off[2];       		/* gcpcorrelate */
    					/* nominal horiz & vert offsets of UL 
    					   corner of reference subimage relative
					   to search subimage */
    CorrFitMethod fit_method;     	/* correlation */
    					/* surface fit method:
    					   FIT_ELLIP_PARA-Elliptical paraboloid
                                           FIT_ELLIP_GAUSS-Elliptical Gaussian
                                           FIT_RECIP_PARA-Reciprocal Paraboloid
                                           FIT_ROUND-Round to nearest int */
    int max_processors_to_use;          /* maximum number of processors to use
                                           for a single gps executable */
    int input_image_scans_to_buffer;    /* the number of scans to buffer from
                                           the input image during resampling */
    int max_output_image_buffer;        /* the maximum size of the output image
                                           buffer, in MB */
    float downsamp_wght;		/* band2band char */
    					/* gpyramid downsampling weight	*/
    float focal_plane_point_weight;     /* weight to assign to each point found
                                           by correlation to the least squares
                                           fit */
    } GPS_SYSTBL;

#endif
