/******************************************************************************
NAME:		gxx_close_gcp_file

PURPOSE:	close the gcp data file

DEVELOPMENT HISTORY:
$Log: gxx_close_gcp_file.c,v $
Revision 1.1.1.1  2000/10/19 14:37:35  morfitt
ram:  Inital EO1 processing system.

Revision 1.1.1.1  1999/12/01 19:01:20  mbs
Import of IAS 3.22

Revision 1.2  1997/06/04 18:27:38  rockvam
Changed source to just include the gxx_utility.h file.
Changed all CMLEN to STRLEN.

Revision 1.1  1997/05/20 20:00:28  rockvam
New gxxUtil functions

Revision 1.2  1997/05/13 14:04:43  rockvam
change gps to gxx, use IAS library functions & defines, use typedefs

Revision 1.1  1997/05/02 18:34:17  rockvam
Initial revision


RETURN VALUE: 
Type = int
Value           Description
-----           -----------
SUCCESS     	Successfully closed file
ERROR     	Error closing file

NOTES:

ALGORITHM REFERENCES:
*******************************************************************************
		Landsat 7 Image Assessment System (IAS) Software
		        Property of the U.S. Government
                                NASA/GSFC/EDC
******************************************************************************/
#include "gxx_utility.h"

int gxx_close_gcp_file (
	FILE *gcp_fptr)		/* I-GCP data file pointer      */
{
if (fclose(gcp_fptr) != 0)
    {
    xxx_LogStatus("GPSLIB",__FILE__,__LINE__,"Error closing GCP data file");
    return(ERROR);
    }
else
    return(SUCCESS);

}
