/*******************************************************************************
NAME:		ANGLEBETWN

PURPOSE:	Calculate the angle in radians between two vectors
		(vectors are 3-element: x,y,z) 

DEVELOPMENT HISTORY:
$Log: xxx_anglebetwn.c,v $
Revision 1.1  2000/11/22 14:19:54  storey
Original Version
Conversion of gxx_anglebetwn.



RETURN VALUE:
No return value
********************************************************************************
                       Property of the U.S. Government
                           USGS EROS Data Center
*******************************************************************************/
#include "xxx_math.h"

void xxx_anglebetwn(const VECTOR *vec1,	/* I: Input vector one		     */	
		   const VECTOR *vec2, 	/* I: Input vector two		     */
		   double *angle)	/* O: Angle between vectors (radians)*/
{
double	tmp;				/* used in error checking calculation */

/*
  Calculate the angle between the specified vectors
*/
tmp = xxx_norm(vec1) * xxx_norm(vec2);
if (tmp == 0.0)
    *angle = 0.0;
else
    *angle = acos(xxx_dot(vec1,vec2) / tmp);

return;
}
