/******************************************************************************
NAME: 		TRANSVEC

PURPOSE:	Transform a vector matrix by multiplication.

PROGRAM HISTORY:
VERSION	DATE	AUTHOR		REASON
-------	----	------		------
$Log: xxx_transvec.c,v $
Revision 1.1  2000/11/22 21:26:20  storey
Original version - conversion from gxx_transvec.c


ALGORITHM DESCRIPTION:

Xnew = Trans * Xold;
*******************************************************************************
			Property of the U.S. Government
			    USGS EROS Data Center
******************************************************************************/
#include "xxx_structures.h"

void xxx_transvec(
    VECTOR Xold,	/* I: vector in old system */
    double Trans[3][3],/* I:transformation matrix from old to new system*/
    VECTOR *Xnew)	/* O: vector in the new system */

{

/*
** Calculate the new vector
*/
Xnew->x  = Trans[0][0] * Xold.x ;
Xnew->x  += Trans[0][1] * Xold.y ;
Xnew->x  += Trans[0][2] * Xold.z ;

Xnew->y  = Trans[1][0] * Xold.x ;
Xnew->y  += Trans[1][1] * Xold.y ;
Xnew->y  += Trans[1][2] * Xold.z ;

Xnew->z  = Trans[2][0] * Xold.x ;
Xnew->z  += Trans[2][1] * Xold.y ;
Xnew->z  += Trans[2][2] * Xold.z ;

return;
}
