/*******************************************************************************
NAME:		xxx_unit

PURPOSE:	
Calculate a vector's unit vector

DEVELOPMENT HISTORY:
$Log: xxx_unit.c,v $
Revision 1.1  2000/11/22 21:26:21  storey
Original version - conversion from gxx_unit.c



RETURN VALUE:
Type = int (SUCCESS or ERROR)

********************************************************************************
                       Property of the U.S. Government
                          USGS EROS Data Center
*******************************************************************************/
#include "xxx_LogStatus.h"
#include "xxx_math.h"

int  xxx_unit(const VECTOR *vec,/* I: Input vector */ 
	      VECTOR *uni) 	/* O: Unit vector of the input vector */
{
double	mag;			/* Magnitude of the input vector */
 
/*
  Find the magnitude of the input vector
*/
mag = xxx_norm(vec);

if (mag == 0.0)
{
   xxx_LogStatus ("XXXLIB", __FILE__, __LINE__, 
                  "Error: input vector magnitude is zero");
   return (ERROR);
}

/*
  Calculate the unit vector
*/
uni->x = vec->x / mag;
uni->y = vec->y / mag;
uni->z = vec->z / mag;
      
return SUCCESS;
}
