/* tminit prototypes */
#ifndef AXX_ALINIT_H
#define AXX_ALINIT_H
#include "xxx_const.h"
#include "xxx_ali_level1r.h"
#include "axx_alimodel.h"
#include "axx_init_model.h"

/* define program name */

#define PROG_NAME	"ALINIT"

/* ********** */
/* structures */
/* ********** */

/*************************/
/* Prototypes for ALINIT */
/*************************/

int getpar(
    char parm_file[STRLEN],	/* I: the name of the input Parm File 	*/
    char cpf_name[STRLEN],	/* O: name of the cpf files		*/
    char hk_data_dir[STRLEN],	/* O: housekeeping data directory 	*/
    char hk_file_root[STRLEN],	/* O: housekeeping file name root 	*/
    char img_data_dir[STRLEN],	/* O: ALI image data directory 		*/
    char img_file_root[STRLEN],	/* O: ALI image file name root 		*/
    char ephemtype[4],		/* O: "ACS" or "GPS" ephemeris option	*/
    char model_file[STRLEN]);	/* O: name of output HDF file		*/

void get_date_time(
    char *text_date,		/* I: Text date/time as YYYYDDDHHMMSS	*/
    double *time );		/* O: Double array as Year, DOY, SOD	*/

int get_image_info(
    char *file_name,                        /*I: filename containing imagery */
    char *sensor_name,                      /*I: Sensor (or band) name */
    L1R_IMAGE_ATTRIBUTES *attributes,       /*O: Structure containing L1R attributes */
    L1R_HEADER *header);                    /*O: Structure containing L1R header info */

int print_amodel(ALIMODEL mod);

#endif
