#ifndef _GET_RESAMPLE_CPF_H_
#define _GET_RESAMPLE_CPF_H_

/*
**
** INCLUDE FILES
**
*/

#include "mtf.h"       /* MTF_PARAMETERS_TYPE definition */
#include "xxx_const.h" /* BandNumber definition */
#include "exx_cpf.h"   /* CPF definition */

/*
**
** MACROS
**
*/

#define MAX_DETECTORS 960
/* The maximum number of detectors to allow for */

/*
**
** TYPE DEFINITIONS
**
*/

typedef struct
{
    float along[MAX_DETECTORS];
    float across[MAX_DETECTORS];
} DETECTOR_OFFSETS_TYPE;

/*
**
** FUNCTION PROTOTYPES
**
*/

int read_resample_cpf();

int read_resample_cpf_mtf();

int read_resample_cpf_offsets(int sca);

const MTF_PARAMETERS_TYPE *get_forward_MTF_weights_along
(
    BandNumber band /* INPUT : band number of weights to retrieve */
);

const MTF_PARAMETERS_TYPE *get_reverse_MTF_weights_along
(
    BandNumber band /* INPUT : band number of weights to retrieve */
);

const MTF_PARAMETERS_TYPE *get_forward_MTF_weights_across
(
    BandNumber band /* INPUT : band number of weights to retrieve */
);

const MTF_PARAMETERS_TYPE *get_reverse_MTF_weights_across
(
    BandNumber band /* INPUT : band number of weights to retrieve */
);

const DETECTOR_OFFSETS_TYPE *get_detector_offsets
(
    BandNumber band /* INPUT : band number of detector offsets to retrieve */
);

CPF *get_cpf(void);

void cleanup_resample_cpf(void);

int get_path_row_parameters(
  double *semi_major,
  double *semi_minor,
  double *inclination,
  double *orbits_per_cycle,
  double *days_per_cycle,
  double *path1_row60,
  double *scenes_per_orbit,
  double *descending_node_row);

#endif
