#ifndef _KERNAL_H_
#define _KERNAL_H_

#include "xxx_const.h"   /* BandNumber definition */
#include "get_resample_parameters.h"    /* RESAMPLE_TYPE definition */

/*
**
** FUNCTION PROTOTYPES
**
*/

int Kernal_Setup
(
    BandNumber band,/* INPUT : current band */
    RESAMPLE_TYPE resampling_type, /* INPUT : resampling type */
    double cc_alpha /* INPUT : cubic convolution alpha parameter */
);

void Cleanup_Kernal(void);

const double *Get_Resample_Weight_Table_Ptr(void);

int get_lines_in_kernal(void);

int get_samples_in_kernal(void);

int num_left_kernal_samples(void);

int num_right_kernal_samples(void);

int num_top_kernal_lines(void);

int num_bottom_kernal_lines(void);

double get_kernal_step_size(void);

void get_kernal_table_info
(
    int *subpixel_steps, /* O: number of subpixel steps in table */
    int *table_entries,  /* O: number of table entries for a whole pixel
                                step (one more than subpixel_steps */
    int *kernal_width,   /* O: width of kernal (samples across kernal) */
    int *kernal_height   /* O: height of kernal (lines across kernal) */
);

#endif /* _KERNAL_H_ */

