#include <stdlib.h>        /* exit prototype */
#include <stdio.h>         /* sprintf prototype */
#include "xxx_Types.h"     /* SUCCESS/ERROR definitions */
#include "xxx_LogStatus.h" /* xxx_LogStatus prototype */
#include "xxx_const.h"     /* ALI constants */
#include "xxx_utility.h"   /* GPS_SYSTBL definition */
#include "axx_hdf_io.h"    /* 1g image I/O */

#define		PROGRAM_NAME		"COMBINE_SCA"

#define ASSERT(f) if (!(f)) \
{   printf ("\nASSERT failed in %s, line number = %d\n",__FILE__, __LINE__); \
   exit (-1); }

int combine(
   HDFIO *input_hdf_io_ptr,     /* output HDF I/O file id */
   HDFIO *output_hdf_io_ptr,      /* input HDF I/O file id */
   DataType dtype,              /* data type of each band of output */
   int image_lines[NSCA][NBANDS],
   int image_samps[NSCA][NBANDS],
   int nbands,
   BandNumber *bands,
   float fill);

int get_parms (
  char param_filename[STRLEN],  /* I: Parameter file name                   */
  char scriptname[STRLEN],      /* O: Script name                           */
  char input_image[STRLEN],     /* O: ALI file name for the 0R image        */
  char output_image[STRLEN],    /* O: ALI file name for the 1R image        */
  int *bands,
  int *nbands,
  float *fill);
