#ifndef _MTF_H_
#define _MTF_H_

/*
**
** TYPEDEFS
**
*/

typedef struct
{
   double am1;   /* alpha minus 1 */
   double a0;    /* alpha 0 */
   double ap1;   /* alpha plus 1 */
   double bm1;   /* beta minus 1 */
   double bp1;   /* beta plus 1 */

} MTF_PARAMETERS_TYPE;
/* parameters that define an MTF resampling kernal. */


/*
**
** FUNCTION PROTOTYPES
**
*/

double mtf_convolution
(
   const MTF_PARAMETERS_TYPE *mtf_param_ptr, /* I: MTF convolution parameters */
   double x  /* I: value to perform MTF convolution on */
);

#endif /* _MTF_H_ */

