#include <stdio.h>
#include "hxx_hypmodel.h"

int print_hmodel(HYPMODEL mod)
{
long i, j;

printf("satnum = %d\n",mod.satnum);
printf("dce_time = %04d %03d %lf\n",(int)(mod.dce_time[0]+0.5),
                                    (int)(mod.dce_time[1]+0.5),
                                    mod.dce_time[2]);
printf("frame_rate = %lf\n", mod.frame_rate);
printf("integration_time = %lf\n", mod.integration_time);
printf("acs_time = %04d %03d %lf\n",(int)(mod.acs_time[0]+0.5),
                                    (int)(mod.acs_time[1]+0.5),
                                    mod.acs_time[2]);
if ( mod.ephem_type == GPSPTS )
  printf("ephem_type = GPS\n");
else
  printf("ephem_type = ACS\n");
printf("nephem = %d\n",mod.nephem);
printf("ephem_time = %04d %03d %lf\n",(int)(mod.ephem_time[0]+0.5),
                                      (int)(mod.ephem_time[1]+0.5),
                                      mod.ephem_time[2]);
for (i = 0; i<mod.nephem; i++)
{
  printf("ECR[%d] = %lf %lf %lf %lf %lf %lf\n",i,mod.ecr_satpos[0][i],
                                                 mod.ecr_satpos[1][i],
                                                 mod.ecr_satpos[2][i],
                                                 mod.ecr_satvel[0][i],
                                                 mod.ecr_satvel[1][i],
                                                 mod.ecr_satvel[2][i]);
}
for (i = 0; i<mod.nephem; i++)
{
  printf("ECI[%d] = %lf %lf %lf %lf %lf %lf\n",i,mod.eci_satpos[0][i],
                                                 mod.eci_satpos[1][i],
                                                 mod.eci_satpos[2][i],
                                                 mod.eci_satvel[0][i],
                                                 mod.eci_satvel[1][i],
                                                 mod.eci_satvel[2][i]);
}
printf("num_det = %d\n", mod.num_det );
for(i = 0; i<HYP_NBAND; i++)
{
   printf("coef_x = %lf %lf %lf\n",mod.coef_x[0],mod.coef_x[1],mod.coef_x[2]);
   printf("coef_y = %lf %lf %lf\n",mod.coef_y[0],mod.coef_y[1],mod.coef_y[2]);
}
printf("nrpy = %d\n", mod.nrpy );
for (i = 0; i<mod.nrpy; i++)
{
  printf("rpy[%d][*] = %e %e %e\n",i,mod.rpy[i][0],mod.rpy[i][1],mod.rpy[i][2]);
}

printf("\nsc_roll = %f\n",mod.sc_roll);
printf("sc_pitch = %f\n",mod.sc_pitch);
printf("sc_yaw = %f\n",mod.sc_yaw);
printf("correction_type = %d\n",mod.correction_type);
printf("p_roll = %f\n",mod.p_roll);
printf("p_rrate = %f\n",mod.p_rrate);
printf("p_pitch = %f\n",mod.p_pitch);
printf("p_prate = %f\n",mod.p_prate);
printf("p_yaw = %f\n",mod.p_yaw);
printf("p_yrate = %f\n",mod.p_yrate);
printf("p_x = %f\n",mod.p_x);
printf("p_vx = %f\n",mod.p_vx);
printf("p_y = %f\n",mod.p_y);
printf("p_vy = %f\n",mod.p_vy);
printf("p_z = %f\n",mod.p_z);
printf("p_vz = %f\n",mod.p_vz);
printf("p_ref_time = %f\n",mod.p_ref_time);
printf("l0r_sw_version = %d.%d.%d\n",mod.l0r_sw_version[0],
       mod.l0r_sw_version[1],mod.l0r_sw_version[2]);

return(SUCCESS);
}
