/*
 *  File:  cp_proto.h
 *
 *  Description:  File with global function prototypes for cal pipeline
 *
 *  Author:       Jenifer Brinker Evans
 *
 *  Date        Author          Action
 * -----------------------------------------------------------------------
 * 07/08/98     JBE             Version 1.1 complete
 *
 */


#ifndef _CP_PROTO_
#define _CP_PROTO_


void CalibrateData(enum sensor_types Sensor, 
		   enum ds_types DataType,
		   short *fpdata, 
		   int32 dim[2], 
		   int32 dim_table[2],
		   int32 along, 
		   float *response_table,
		   float *offset_data, 
		   float *response_data, 
		   short *cal_data,
		   float integ_time,
		   int32 sca_num,
		   int32 band);

int32 ComputeFrameShifts(int32 frame_shift[MAX_SENSORS][MAX_BANDS], 
		       int32 sca_num,
		       float speed);

void WriteLeadFill(enum sensor_types Sensor, short *data,
		   int32 shift, 
		   int32 MaxFrameShift, int32 edge[3],
		   int32 cross, int32 along, int32 band);



void GracefulExit();


void CalibrateLeakyPixels(enum sensor_types Sensor,
			  enum ds_types DataType,
		   short *fpdata, 
		   int32 dim[2], 
		   int32 dim_table[2],
		   int32 along, 
		   float *lp_gain_data,
		   float *offset_data, 
		   float *response_data, 
		   short *cal_data,
		   float integ_time,
		   int32 sca_num,
		   int32 band);

void ReadLeakyGains(enum sensor_types Sensor, float *lp_gain_data);

void ComputeOffsetCoeff(enum sensor_types Sensor, float *offset_data, int32 band, 
			int32 read);

void ComputeResponseCoeff(enum sensor_types Sensor,  enum ds_types DataType,
			  float *response_table, int32 dim_table[2], int32 band);

int ReadStoredOffsetCoeff(enum sensor_types Sensor, 
			  float *offset_data, 
			  int32 band, int32 read);

void PrepareOutputFile(int32 *sd_1r_id, float version);

void svdfit(float x[], float y[], int ndata, float a[], int ma,
	float u[][], float v[][], 
	    float w[],void (*funcs)(float, float [], int));

void svdcmp(float a[][], int m, int n, float w[], 
	    float v[][]);

void svbksb(float u[][], float w[], 
	    float v[][], int m, int n, float b[], float x[]);

int index2(int i,int j,int32 *dim);

#endif	/* ifndef _CP_PROTO_ */
