/*
 *  File:  cp_structs.h
 *
 *  Description:  File with structures for File & SDS Attributes
 *
 *  Author:       Jenifer Brinker Evans
 *
 *  Date        Author          Action
 * -----------------------------------------------------------------------
 * 02/19/98     JBE             Version 1.1 complete
 *
 * 03/24/98     MDG             added PRCNT_MISS for percent missing data
 *
 * 04/02/98	MDG		separated Dataset attributes from File
 *				  attributes
 * 04/06/98	MDG		changed file name from param.h to cp_structs.h
 * 03/20/99	MDG		added Dataset attributes INTEG_TIME and
 *				  FRAME_RATE
 *  2/14/01     JBE             added new fields to structures for additional
 *                                data attributes Scene_Id and Target_Desc.
 *  2/14/01     JBE             added second variables for INTEG_TIME and 
 *                                FRAME_RATE to handle new GSFC format after
 *                                2/15/01.  Kept old variables for backwards
 *                                compatibility.  Better than compiler option.
 *
 */


#ifndef _CP_STRUCTS_
#define _CP_STRUCTS_


typedef struct rel_name_type REL_NAME;
typedef struct fill_type DATA_FILL;
typedef struct gain_inputtype GAIN_DB;
typedef struct inputtype PARAM_IN;
typedef struct ds_inputtype DATA_SET;



struct rel_name_type
{
  char  filename[21];
};


struct inputtype
{
  char  NAME[30];
  short LEVEL;
  short LZP_VERSION[3];
  short ENDIAN;
  char  GEN_TIME[14];
  char  DCE_TYPE[4];
  short NUM_REL;
  REL_NAME  RNAME[25];
  char  NOTES[2000];
  float CP_VERSION;
  char  CP_NOTES[2000];
  char  SCENE_ID[21];  
  char  TARG_DESC[65];
  char  CP_DBASE[50];  
};

struct ds_inputtype
{
  boolean EXISTS;
  int32 SDS_ID;
  char  SENSOR[3];
  char  DS_TYPE[12];
  char  START[14];
  float DURATION;
  short INTEG_TIME_INT;
  short FRAME_RATE_INT;
  float INTEG_TIME_FLT;
  float FRAME_RATE_FLT;
  short CROSS;
  int32 ALONG;
  short BANDS;
  short PRCNT_MISS;
  short SCALE;
};


struct gain_inputtype
{
  short EXISTS;
  int32 SDS_ID;  
  char  SENSOR[3];
  short CROSS;
  short BANDS;
  short LENGTH;
};


/* function prototypes */

void   ReadParamIns( ) ;



#endif /*ifndef _CP_STRUCTS_ */











