; Opens HDF files and returns attributes
; 
; Release 0.0b: March 1999 Lawrence Ong
;
; Revisions: 
;
;   Dec 20, 1999  Lawrence Ong    Modified display attributes
;   May 14, 2002  Lawrence Ong    Added some comments
;

PRO OPEN_HDF,filename,arrsize,datasets,sds_id,sd_id,dsname,attrname,sds_name,VERBOSE=VERBOSE

; Open the file  **************************************************************
    sd_id = HDF_SD_START(filename, /READ)

; Determine the number of datasets and attributes in the file
    HDF_SD_FILEINFO, sd_id, datasets, attributes 
    if (keyword_set(VERBOSE)) then PRINT, "DATASETS = ", datasets
    if (keyword_set(VERBOSE)) then print,"File attributes: "
    for gindex=0,attributes-1 do begin
        HDF_SD_ATTRINFO,sd_id,gindex,NAME=name,TYPE=type,COUNT=count,DATA=data
        if (keyword_set(VERBOSE)) then print,'Attr. ',gindex,': ',name,', ',type,$
          ', ',count,', ',data
    endfor

    if (keyword_set(VERBOSE)) then print,"------------"
    arrsize=lonarr(3,datasets)
    
; Assign sds_id to each dataset
    sds_id = LONARR(datasets)
    dsname=strarr(datasets)
    sds_name=strarr(datasets)
    tmp=string(' ',format='(A12)')
    attrname=replicate(tmp,datasets)
;    attrname=strarr(datasets)
    FOR i = 0, (datasets-1) DO BEGIN
        num = i + 1
        sds_id(i) = HDF_SD_SELECT(sd_id, i) 
        
                                ; Verify the characteristics of the array
        HDF_SD_GETINFO, sds_id(i), NDIMS = rank, DIMS = dims, $
          NAME = sds_name0, HDF_TYPE = data_type, NATTS = data_attrs, $
          FORMAT=format,Label=label
        sds_name(i)=string(sds_name0)
        if (keyword_set(VERBOSE)) then begin
            print,'NDIMS: ',rank
            print,'DIMS: ',dims
            print,'Name: ',sds_name0
            print,'HDF_Type: ',data_type
            print,'NATTS: ',data_attrs
            print,'Format: ',format
            print,'Label: ',label          
            PRINT, FORMAT = '(" ")'
            PRINT, FORMAT = '("Dataset  ",I3,": ",A20)', num, sds_name(i)
        endif
            
            FOR j = 0, (rank-1) DO BEGIN
                if (keyword_set(VERBOSE)) then $
                  PRINT, FORMAT='("   Dimension ",I1,": ",I5)',j, dims(j)
                arrsize(j,i)=dims(j)
            ENDFOR

;;        gindex=HDF_SD_ATTRFIND(sd_id(i),'L0 File Generated By')
        for gindex=0,data_attrs-1 do begin
            HDF_SD_ATTRINFO,sds_id(i),gindex,NAME=name,TYPE=type,COUNT=count,DATA=data
            if (keyword_set(VERBOSE)) then $
              print,'Attr. ',gindex,': ',name,', ',type,$
              ', ',count,', ',data
            case 1 of
                name eq 'ALI Sensor': begin
                    dsname[i] = string(data)
                end
                name eq 'Dataset Type': begin
                    attrname[i] = string(data)
                end
                name eq 'SensorType': dsname[i]=string(data)
                name eq 'DatasetType': begin
                    attrname[i] = string(data)
                end                
                else:
            endcase
        endfor

    ENDFOR
    
RETURN

END	










