:
#
# daily_checks.sh
#
# This script checks several things and emails the results.
#

#
# DEFINE SHELL VARIABLES AND REMOVE THE OLD MESSAGE FILE.
#

RUN_DIR=/home/edclxs37/eo1/bin/daily
LOG_DIR=/home/edclxs37/eo1
MSG=$RUN_DIR/msg.txt
rm $MSG > /dev/null 2>&1


#
# SEE IF EO1 HAS ANY MAIL THAT NEEDS TO BE READ
#

if [ -s /var/spool/mail/eo1 ]; then
  echo -e "*************************             *************************" >> $MSG
  echo -e "************************* MAIL EXISTS *************************" >> $MSG
  echo -e "*************************             *************************" >> $MSG
else
  echo -e "*************************         *************************" >> $MSG
  echo -e "************************* NO MAIL *************************" >> $MSG
  echo -e "*************************         *************************" >> $MSG
fi


#
# SEND THE LOGS THEN MOVE THEM TO THE ARCHIVE
#
#  WE ONLY WANT TO DO THIS IF THE LEVEL 0 PROCESSING IS **NOT** RUNNING
#  WE CHECK TO SEE IF THE *LOCK* FILE EXISTS AND JUST WAIT UNTIL IT'S GONE
#

while [ -e /home/edclxs37/eo1/lock ]
do
  sleep 2
done

echo -e "\n*************************               *************************" >> $MSG
echo -e "************************* EO1INGEST.LOG *************************" >> $MSG
echo -e "*************************               *************************\n" >> $MSG
cat $LOG_DIR/eo1ingest.log  >> $MSG

echo -e "\n*************************            *************************" >> $MSG
echo -e "************************* INGEST.OUT *************************" >> $MSG
echo -e "*************************            *************************\n" >> $MSG
cat $LOG_DIR/ingest/ingest.out >> $MSG

echo -e "\n*************************            *************************" >> $MSG
echo -e "************************* INGEST.ERR *************************" >> $MSG
echo -e "*************************            *************************\n" >> $MSG
cat $LOG_DIR/ingest/ingest.err | grep -v -f $RUN_DIR/grepfile - >> $MSG


#
# LOOK FOR FILES ON THE RAID BUY ARE NOT ON THE SILO
#

echo -e "\n***************                                   ***************" >> $MSG
echo -e "*************** FILES ON RAID BUT NOT ON THE SILO ***************" >> $MSG
echo -e "***************                                   ***************" >> $MSG
RAID=$RUN_DIR/filematchup.raid; export RAID
SILO=$RUN_DIR/filematchup.silo; export SILO

START_PT=eo1/2006/2*
find /edclxs37/$START_PT -follow -type f -print > $RAID
find /hsm/lta1/$START_PT -type f -print > $SILO 2>/dev/null

$RUN_DIR/filematchup.pl >> $MSG 2>&1

#
# MONITOR L0 USAGE ON RAID
#

echo -e "\n***************                                    ***************" >> $MSG
echo -e "***************           RAID MONITORING          ***************" >> $MSG
echo -e "***************   WE'RE WATCHING /edclxs37/data3   ***************" >> $MSG
echo -e "***************   2006 233-365  Good until 12/31   ***************" >> $MSG
echo -e "***************                                    ***************\n" >> $MSG

df -h -l >> $MSG


#
# LOOK FOR DATABASE RECORDS THAT NEED TO BE REGENERATED BECAUSE OF MISSING COORDINATES
#

echo -e "\n****                                                       ****" >> $MSG
echo -e "**** MISSING ALI OR HYP DB COORDINATES IN THE LAST 30 DAYS ****" >> $MSG
echo -e "****                                                       ****\n" >> $MSG
$RUN_DIR/regen.pl >> $MSG


#
# LOOK FOR MISSING DATA
#

echo -e "\n***************                                     ***************" >> $MSG
echo -e "*************** MISSING L0 DATA PER META/DAILY FILE ***************" >> $MSG
echo -e "***************      (FOR FULL WEEK 2 WKS AGO)      ***************" >> $MSG
echo -e "***************                                     ***************\n" >> $MSG
$RUN_DIR/L0datacheck.pl -v >> $MSG 2>&1
