#!/usr/bin/perl
#
# filematchup.pl
#
# Compare a list of files on the RAID with a list of files on the Silo.
#

use strict;

my $raid_files = $ENV{'RAID'};
my $silo_files = $ENV{'SILO'};

my %raid;
my %silo;

open(RAID, "<$raid_files") || die("$raid_files: $!");
open(SILO, "<$silo_files") || die("$silo_files: $!");

while (<RAID>) {
  chomp;
  if (s"/edclxs37/eo1/(\d\d\d\d)/"$1/") {
    $raid{$_} = 1;
  }
}
close(RAID);

while (<SILO>) {
  chomp;
  if (s"/hsm/lta1/eo1/(\d\d\d\d)/"$1/") {
    $silo{$_} = 1;
  }
}
close(SILO);

foreach my $file (sort keys %raid) {
  my @silo_stat = stat("/hsm/lta1/eo1/$file");
  my @raid_stat = stat("/edclxs37/eo1/$file");

  if ($silo_stat[7] != $raid_stat[7]) {
    print "cp /edclxs37/eo1/$file /hsm/lta1/eo1/$file\n";
  }
}
