#!/usr/bin/perl
#
# filematchup.pl
#
# Compare a list of files on the RAID with a list of files on the Silo.
#

#use strict;

# my $raid_files = "/home/edclxs37/eo1/bin/daily/filematchup.raid";
# my $silo_files = "/home/edclxs37/eo1/bin/daily/filematchup.silo";
my $raid_files = $ENV{'RAID'};
my $silo_files = $ENV{'SILO'};

umask(002);

my %raid;
my %silo;

open(RAID, "<$raid_files") || die("$raid_files: $!");
open(SILO, "<$silo_files") || die("$silo_files: $!");

while (<RAID>) {
  chomp;
  if (s"/edclxs37/eo1/(\d\d\d\d)/"$1/") {
    $raid{$_} = 1;
  }
}
close(RAID);

while (<SILO>) {
  chomp;
  if (s"/hsm/lta1/eo1/(\d\d\d\d)/"$1/") {
    $silo{$_} = 1;
  }
}
close(SILO);

foreach my $file (sort keys %raid) {
  my @silo_stat = stat("/hsm/lta1/eo1/$file");

  my @raid_stat = stat("/edclxs37/eo1/$file");

  if ($silo_stat[7] != $raid_stat[7]) {
    $rfile = "/edclxs37/eo1/$file";
    $sfile = "/hsm/lta1/eo1/$file";
    print "\nRE-COPYING $file\n";
    mkdirsfor($sfile);
    copyr2s($rfile,$raid_stat[7],$sfile);
    print " DONE\n";
  }
}

sub mkdirsfor {
  my ($file) = @_;

  $file =~ s?/[^/]*$??; # strip off filename

  if ( ! -d "$file" ) {
    $syscall = "mkdir -p $file 2>/dev/null";

    $rtn = 1;
    while ($rtn) { # keep trying until directory(s) is/are made
      $rtn = 0xffff & system ($syscall);
      print ".";

      if ($rtn != 0) {
        sleep (10);
      }
    }
  }
}

sub copyr2s {
  my ($rfile,$rstat,$sfile) = @_;

  $syscall = "cp $rfile $sfile";

  $rtn = 1;
  while ($rtn) { # keep trying until copy works
    system ($syscall);
    print " .";

    @silo_stat = stat("$sfile");

    if ($silo_stat[7] != $rstat) { # works if same size
      unlink ("$sfile");
      sleep (10);
    } else {
      $rtn = 0;
    }
  }
}
