#!/usr/bin/perl -I/usr/local/lib/perl5/site_perl

my $N = int($ARGV[0]) || 45;        # Number of days back to check
umask(002);

$ENV{PATH} = "/usr/local/bin:$ENV{PATH}";

#
# Constaints
#
#  Generate corner directory and program
#
$gcd = '/home/eo1/inventory/footprint';
$gcp = '/home/eo1/inventory/footprint/gencorners.pl';
#
#  Regen directory and program
#
$rd = '/home/eo1/regens';
$rp = '/home/eo1/bin/regenmetadata.pl';
#
#  Meta builder
#
$gmdp = '/home/eo1/bin/genmetadata.pl';
#
# Misc
#
$ali1 = 1;
$hyp1 = 1;
$today = `date +%y%m%d`;
chomp $today;

#
# Find dates of missing corners for the last $N days
#
$sql = "\"/home/neiers/db_select-new eo1 'select unique substr(entity_id,11,7) from eo1_hyp where trunc(date_entered) > trunc(sysdate-$N) and substr(entity_id,18,3) = :110: and ll_lat = 0 and ll_lon = 0'\"";

@rslt = `ssh -q neiers\@edclxs152 $sql`;

#
# We found some
#
if (@rslt) {
  $x = '';
  foreach (@rslt) {
    m"(\d\d\d\d)(\d\d\d)";
    $x = $x . ' ' . $1 . '/' . $2;
  }
  print "ATTEMPTING CORNERS REGENERATION FOR DATES:$x\n\n";

#
# Change to corner directory and force rebuild for all dates
#
  chdir ($gcd);
  `$gcp -F $x > /dev/null 2>&1`;

#
# Change to regen directory to save files
#
  chdir ($rd);

#
# Get ALI ids to rebuild - those missing corners
#
  $sql = "\"/home/neiers/db_select-new eo1 'select entity_id from eo1_ali where trunc(date_entered) > trunc(sysdate-$N) and substr(entity_id,18,3) = :110: and ll_lat = 0 and ll_lon = 0 order by substr(entity_id,11,7),entity_id'\"";

  @rslt = `ssh -q neiers\@edclxs152 $sql`;

  foreach (@rslt) {
    chomp;
    print "Regenerating: $_";

    system("$rp $_ > regen.tmp 2>&1"); # redirect all to a file
    $rec = `grep "^$_" regen.tmp`; # we want data line only

    if ($rec ne '') {
      @fields = split(/\|/,$rec);

      if ($fields[18] ne '' && $fields[19] ne '') {
        if ($ali1) {
          open(ALI_FP, ">man_update.ali");
          $ali1 = 0;
        }
        print ALI_FP "$rec";
        print " - corners found\n";
      } else {
        print " - corners NOT found\n";
      }
    }
  }
#
# Get HYP ids to rebuild - those missing corners
#
  $sql = "\"/home/neiers/db_select-new eo1 'select entity_id from eo1_hyp where trunc(date_entered) > trunc(sysdate-$N) and substr(entity_id,18,3) = :110: and ll_lat = 0 and ll_lon = 0 order by substr(entity_id,11,7),entity_id'\"";

  @rslt = `ssh -q neiers\@edclxs152 $sql`;

  print "\n";

  foreach (@rslt) {
    chomp;
    print "Regenerating: $_";

    system("$rp $_ > regen.tmp 2>&1"); # redirect all to a file
    $rec = `grep "^$_" regen.tmp`; # we want data line only

    if ($rec ne '') {
      @fields = split(/\|/,$rec);

      if ($fields[18] ne '' && $fields[19] ne '') {
        if ($hyp1) {
          open(HYP_FP, ">man_update.hyp");
          $hyp1 = 0;
        }
        print HYP_FP "$rec";
        print " - corners found\n";
      } else {
        print " - corners NOT found\n";
      }
    }
  }
#
# Rebuild corner files
#
  if ($ali1 == 0) {
    close(ALI_FP);
    `$gmdp man_update.ali`;
  }

  if ($hyp1 == 0) {
    close(HYP_FP);
    `$gmdp man_update.hyp`;
  }
}
#
# Now look for missing look angles
#
$ali2 = 1;
$hyp2 = 1;
print "\nATTEMPTING LOOK ANGLE REGENERATION\n\n";
#
# Get ALI ids to rebuild - those missing look angles
#
$sql = "\"/home/neiers/db_select-new eo1 'select entity_id from eo1_ali where trunc(date_entered) > trunc(sysdate-$N) and substr(entity_id,18,3) = :110: and look_angle = 0 order by substr(entity_id,11,7),entity_id'\"";

@rslt = `ssh -q neiers\@edclxs152 $sql`;

foreach (@rslt) {
  chomp;
  print "Regenerating: $_";

  system("$rp $_ > regen.tmp 2>&1"); # redirect all to a file
  $rec = `grep "^$_" regen.tmp`; # we want data line only

  if ($rec ne '') {
    @fields = split(/\|/,$rec);

    if ($fields[38] != 0) {
      if ($ali2) {
        open(ALI_FP, ">>man_update.ali");
        $ali2 = 0;
      }
      print ALI_FP "$rec";
      print " - look angle found\n";
    } else {
      print " - look angle NOT found\n";
    }
  }
}
#
# Get HYP ids to rebuild - those missing look angles
#
$sql = "\"/home/neiers/db_select-new eo1 'select entity_id from eo1_hyp where trunc(date_entered) > trunc(sysdate-$N) and substr(entity_id,18,3) = :110: and look_angle = 0 order by substr(entity_id,11,7),entity_id'\"";

@rslt = `ssh -q neiers\@edclxs152 $sql`;

print "\n";

foreach (@rslt) {
  chomp;
  print "Regenerating: $_";

  system("$rp $_ > regen.tmp 2>&1"); # redirect all to a file
  $rec = `grep "^$_" regen.tmp`; # we want data line only

  if ($rec ne '') {
    @fields = split(/\|/,$rec);

    if ($fields[43] != 0) {
      if ($hyp2) {
        open(HYP_FP, ">>man_update.hyp");
        $hyp2 = 0;
      }
      print HYP_FP "$rec";
      print " - look angle found\n";
    } else {
      print " - look angle NOT found\n";
    }
  }
}
#
# Copy files to LTA machine and rename
#
if ($ali2 == 0) {
  close(ALI_FP);
}
if (($ali1 == 0) || ($ali2 == 0)) {
  `scp -q man_update.ali neiers\@edclxs152:/inv/inv/eo1/data/man_update.ali`;
  rename ("man_update.ali","man_update.ali-$today");
}

if ($hyp2 == 0) {
  close(HYP_FP);
}
if (($hyp1 == 0) || ($hyp2 == 0)) {
  `scp -q man_update.hyp neiers\@edclxs152:/inv/inv/eo1/data/man_update.hyp`;
  rename ("man_update.hyp","man_update.hyp-$today");
}

