#!/usr/bin/perl -I/usr/local/lib/perl5/site_perl

umask(002);

$ENV{PATH} = "/usr/local/bin:$ENV{PATH}";

#
# Constaints
#
#  Generate corner directory and program
#
$gcd = '/home/edclxs37/eo1/inventory/footprint';
$gcp = '/home/edclxs37/eo1/inventory/footprint/gencorners.pl';
#
#  Regen directory and program
#
$rd = '/home/edclxs37/eo1/regens';
$rp = '/home/edclxs37/eo1/bin/regenmetadata.pl';
#
#  Meta builder
#
$gmdp = '/home/edclxs37/eo1/bin/genmetadata.pl';
#
#  Day to regenerate passed in as an argument (yyyy/ddd format)
#
$genday = $ARGV[0];
$yyyyddd = substr($genday,0,4) . substr($genday,5,3);
#
# Misc
#
$ali1 = 1;
$hyp1 = 1;
$today = `date +%y%m%d`;
chomp $today;

  print "Attempting regeneration for date:$genday\n";

#
# Change to corner directory and force rebuild
#
  chdir ($gcd);
  `$gcp -F $genday > /dev/null 2>&1`;

#
# Change to regen directory to save files
#
  chdir ($rd);

#
# Get ALI ids to rebuild
#
  $sql = "\"/home/krine/db_select-new eo1 'select entity_id from eo1_ali where substr(entity_id,1,4) = :EO1A: and substr(entity_id,11,7) = :$yyyyddd: order by entity_id'\"";

  @rslt = `ssh krine\@edclxs53 $sql`;

  foreach (@rslt) {
    chomp;
    print "\nAttempting regeneration for: $_";

    system("$rp $_ > regen.tmp 2>&1"); # redirect all to a file
    $rec = `grep "^$_" regen.tmp`; # we want data line only

    if ($rec ne '') {
      @fields = split(/\|/,$rec);

      if ($fields[18] ne '' && $fields[19] ne '') {
        if ($ali1) {
          open(ALI_FP, ">man_update.ali");
          $ali1 = 0;
        }
        print ALI_FP "$rec";
        print " - corners found\n";
      } else {
        print " - no corners yet\n";
      }
    }
  }
#
# Get HYP ids to rebuild
#
  $sql = "\"/home/krine/db_select-new eo1 'select entity_id from eo1_hyp where substr(entity_id,1,4) = :EO1H: and substr(entity_id,11,7) = :$yyyyddd: order by entity_id'\"";

  @rslt = `ssh krine\@edclxs53 $sql`;

  foreach (@rslt) {
    chomp;
    print "\nAttempting regeneration for: $_";

    system("$rp $_ > regen.tmp 2>&1"); # redirect all to a file
    $rec = `grep "^$_" regen.tmp`; # we want data line only

    if ($rec ne '') {
      @fields = split(/\|/,$rec);

      if ($fields[18] ne '' && $fields[19] ne '') {
        if ($hyp1) {
          open(HYP_FP, ">man_update.hyp");
          $hyp1 = 0;
        }
        print HYP_FP "$rec";
        print " - corners found\n";
      } else {
        print " - no corners yet\n";
      }
    }
  }
#
# Copy files to LTA machine and rename
#
  if ($ali1 == 0) {
    close(ALI_FP);
    `$gmdp man_update.ali`
    `scp -q man_update.ali ops\@edclxs53:/inv/inv/eo1/data/man_update.ali`;
    rename ("man_update.ali","man_update.ali-$today");
  }

  if ($hyp1 == 0) {
    close(HYP_FP);
    `$gmdp man_update.hyp`
    `scp -q man_update.hyp ops\@edclxs53:/inv/inv/eo1/data/man_update.hyp`;
    rename ("man_update.hyp","man_update.hyp-$today");
  }

