% This function unitizes a series of column vectors...
%
%  INPUT:  
%          u(nxm)  Input column vectors.
%  OUTPUT:
%          u(nxm)  Output unitized column vectors.
%  EXTERNAL REFERENCES:  NONE.
%  MODIFICATIONS:  Created.  -R. Harman  3/13/95.
%                  Optimized.  -R. Harman  11/24/95.
%
%function [u]=unitvec(u);

function [u]=unitvec(u);

p=size(u,1);

umag=sqrt(sum(u.*u))';

u = u./umag(:,ones(1,p))';
